###############################################################################
# MessageIndex.pl                                                             #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.1                                                    #
# Released:       November 8, 2005                                            #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2005 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
###############################################################################

$messageindexplver = 'YaBB 2.1 $Revision: 1.7 $';
if ($action eq 'detailedversion') { return 1; }
if(-e("$vardir/RatingConf.txt"))  { require "$vardir/RatingConf.txt"; LoadLanguage("RateIT"); }

LoadLanguage("BoardIndex");
LoadLanguage("QuickReply");
LoadLanguage("MessageIndex");
LoadLanguage("SubBoard");
require "$templatesdir/$usemessage/MessageIndex.template";
require "$sourcedir/Favorites.pl";
&ShowFav;


### AK108 Board Index User Cache
### Leech from the boardindex cache to steal the speed bonus, too.
if(-e "$vardir/boardindexusers.cache") {
	# Trap any syntax errors that might be in the file
	eval 'require "$vardir/boardindexusers.cache"';

	# You can trap errors here by uncommenting the following if statement
	# And putting something inside the block
	#if($@) {} # the code in the if block is executed if there is an error

	# It is probably a good idea to remove the file if it's bad.
	if($@) {unlink "$vardir/boardindexusers.cache";}
}

sub MessageIndex {
	# Check if board was 'shown to all' - and whether they can view the board
	if (&AccessCheck($currentboard, '', $boardperms) ne "granted") { &fatal_error("$maintxt{'1'}"); }
	if ($annboard eq $currentboard && !$iamadmin && !$iamgmod) { &fatal_error("$maintxt{'1'}"); }

	if ($pboard{"$currentboard"} ne "") {
		my @parents = ();
		@parents = split(/\|/, $pboard{"$currentboard"});
		foreach $parent (@parents) {
			($board_name, $board_perms, $board_view) = split(/\|/, $board{"$parent"});
			my $access = &AccessCheck($parent, '', $board_perms);
			if (!$iamadmin && $access ne "granted" && $board_view != 1) { &fatal_error("$maintxt{'1'}"); }
		}
	}
	my ($counter, $buffer, $pages, $showmods, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $dlp, $threadlength, $threaddate);
	my (@boardinfo, @threads, @anns, @stickythreadlist);
	&BoardTotals("load", $currentboard);
if ($enable_ratings) {
	my ($dummy2, $cntrateboard, $cntbrateenable, $cntautoapplyrate, $cntviewrateindex, $cntratestar, $cntrategraph, $cntboardratelst);
	fopen(RATECONTROL, "+<$boardsdir/rate.cntr");
	seek RATECONTROL, 0, 0;
	my @boardratecontrols = <RATECONTROL>;
	fclose(RATECONTROL);
	foreach my $boardrateline (@boardratecontrols) {
		$boardrateline =~ s/[\r\n]//g;
		chomp $boardrateline;
		($dummy2, $cntrateboard, $cntbrateenable, $cntautoapplyrate, $cntviewrateindex, $cntratestar, $cntrategraph, $cntboardratelst) = split(/\|/, $boardrateline);
		if ($currentboard eq $cntrateboard) {
			${$uid.$cntrateboard}{'brate_enable'} = $cntbrateenable;
			${$uid.$cntrateboard}{'apply_arate'} = $cntautoapplyrate;
			${$uid.$cntrateboard}{'view_arate'} = $cntviewrateindex;
			${$uid.$cntrateboard}{'view_ratestar'} = $cntratestar;
			${$uid.$cntrateboard}{'view_rategraph'} = $cntrategraph;
			${$uid.$cntrateboard}{'view_bratelst'} = $cntboardratelst;
		}
	}
}
	my $threadcount  = ${$uid.$currentboard}{'threadcount'};
	my $messagecount = ${$uid.$currentboard}{'messagecount'};
	### Start Message Index with Board Picture mod
	my $bdpic        = ${$uid.$currentboard}{'pic'};
	### End Message Index with Board Picture Mod

	# Load announcements, if they exist.
	if ($annboard && $annboard ne $currentboard) {
		chomp $annboard;
		fopen(ANN, "$boardsdir/$annboard.txt");
		@tmpanns = <ANN>;
		fclose(ANN);
		$numanns = 0;
		foreach $realanns (@tmpanns) {
			my @annarray = split(/\|/, $realanns);
			my $annstatus = pop(@annarray);
			if ($annstatus =~ /a/i) {
				$anns[$numanns] = $realanns;
				$numanns++;
			}
		}
	} else {
		@anns = ();
	}

	$threadcount = $threadcount + $numanns;
	my $maxindex = $INFO{'view'} eq 'all' ? $threadcount : $maxdisplay;


	# There are three kinds of lies: lies, damned lies, and statistics.
	# - Mark Twain


	# Construct the page links for this board.
	if (!$iamguest) {
		($usermessagepage, undef, undef) = split(/\|/, ${$uid.$username}{'pageindex'});
	}
	my ($pagetxtindex, $pagetextindex, $pagedropindex1, $pagedropindex2, $all, $allselected);
	$indexdisplaynum = 3;              # max number of pages to display
	$dropdisplaynum  = 10;
	$startpage       = 0;
	$max             = $threadcount;
	if ($INFO{'start'} eq "all") { $maxindex = $max; $all = 1; $allselected = qq~ selected="selected"~; $start = 0 }
	else { $start = $INFO{'start'} || 0; }
	if ($start > $threadcount - 1) { $start = $threadcount - 1; }
	elsif ($start < 0) { $start = 0; }
	$start    = int($start / $maxindex) * $maxindex;
	$tmpa     = 1;
	$pagenumb = int(($threadcount - 1) / $maxindex) + 1;

	if ($start >= (($indexdisplaynum - 1) * $maxindex)) {
		$startpage = $start - (($indexdisplaynum - 1) * $maxindex);
		$tmpa = int($startpage / $maxindex) + 1;
	}
	if ($threadcount >= $start + ($indexdisplaynum * $maxindex)) { $endpage = $start + ($indexdisplaynum * $maxindex); }
	else { $endpage = $threadcount }
	$lastpn     = int(($threadcount - 1) / $maxindex) + 1;
	$lastptn    = ($lastpn - 1) * $maxindex;
	$pageindex1 = qq~<span class="small" style="float: left; height: 21px; margin: 0px; margin-top: 2px;"><img src="$imagesdir/index_togl.gif" border="0" alt="" style="vertical-align: middle;" /> $messageindex_txt{'139'}: $pagenumb</span>~;
	$pageindex2 = $pageindex1;
	if ($pagenumb > 1 || $all) {

		if ($usermessagepage == 1 || $iamguest) {
			$pagetxtindexst = qq~<span class="small" style="float: left; height: 21px; margin: 0px; margin-top: 2px;">~;
			if (!$iamguest) { $pagetxtindexst .= qq~<a href="$scripturl?board=$INFO{'board'};start=$start;action=messagepagedrop"><img src="$imagesdir/index_togl.gif" border="0" alt="$messageindex_txt{'19'}" style="vertical-align: middle;" /></a> $messageindex_txt{'139'}: ~; }
			else { $pagetxtindexst .= qq~<img src="$imagesdir/index_togl.gif" border="0" alt="" style="vertical-align: middle;" /> $messageindex_txt{'139'}: ~; }
			if ($startpage > 0)          { $pagetxtindex = qq~<a href="$scripturl?board=$currentboard/0" style="font-weight: normal;">1</a>&nbsp;...&nbsp;~; }
			if ($startpage == $maxindex) { $pagetxtindex = qq~<a href="$scripturl?board=$currentboard/0" style="font-weight: normal;">1</a>&nbsp;~; }
			for ($counter = $startpage; $counter < $endpage; $counter += $maxindex) {
				$pagetxtindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$scripturl?board=$currentboard/$counter" style="font-weight: normal;">$tmpa</a>&nbsp;~;
				$tmpa++;
			}
			if ($endpage < $threadcount - $maxindex) { $pageindexadd = qq~...&nbsp;~; }
			if ($endpage != $threadcount) { $pageindexadd .= qq~<a href="$scripturl?board=$currentboard/$lastptn" style="font-weight: normal;">$lastpn</a>~; }

			$pagetxtindex .= qq~$pageindexadd~;
			$pageindex1 = qq~$pagetxtindexst$pagetxtindex</span>~;
			$pageindex2 = $pageindex1;
		} else {
			$pagedropindex1 = qq~<span style="float: left; width: 320px; margin: 0px; margin-top: 2px; border: 0px;">~;
			$pagedropindex1 .= qq~<span style="float: left; height: 21px; margin: 0; margin-right: 4px;"><a href="$scripturl?board=$INFO{'board'};start=$start;action=messagepagetext"><img src="$imagesdir/index_togl.gif" border="0" alt="$messageindex_txt{'19'}" /></a></span>~;
			$pagedropindex2 = $pagedropindex1;
			$tstart         = $start;
			if (substr($INFO{'start'}, 0, 3) eq "all") { ($tstart, $start) = split(/\-/, $INFO{'start'}); }
			$d_indexpages = $pagenumb / $dropdisplaynum;
			$i_indexpages = int($pagenumb / $dropdisplaynum);
			if ($d_indexpages > $i_indexpages) { $indexpages = int($pagenumb / $dropdisplaynum) + 1; }
			else { $indexpages = int($pagenumb / $dropdisplaynum) }
			$selectedindex = int(($start / $maxindex) / $dropdisplaynum);

			if ($pagenumb > $dropdisplaynum) {
				$pagedropindex1 .= qq~<span style="float: left; height: 21px; margin: 0;"><select size="1" name="decselector1" id="decselector1" style="font-size: 9px; border: 2px inset;" onchange="if(this.options[this.selectedIndex].value) SelDec(this.options[this.selectedIndex].value, 'xx')">\n~;
				$pagedropindex2 .= qq~<span style="float: left; height: 21px; margin: 0;"><select size="1" name="decselector2" id="decselector2" style="font-size: 9px; border: 2px inset;" onchange="if(this.options[this.selectedIndex].value) SelDec(this.options[this.selectedIndex].value, 'xx')">\n~;
			}
			for ($i = 0; $i < $indexpages; $i++) {
				$indexpage  = ($i * $dropdisplaynum) * $maxindex;
				$indexstart = ($i * $dropdisplaynum) + 1;
				$indexend   = $indexstart + ($dropdisplaynum - 1);
				if ($indexend > $pagenumb)    { $indexend   = $pagenumb; }
				if ($indexstart == $indexend) { $indxoption = qq~$indexstart~; }
				else { $indxoption = qq~$indexstart-$indexend~; }
				$selected = "";
				if ($i == $selectedindex) {
					$selected    = qq~ selected="selected"~;
					$pagejsindex = qq~$indexstart|$indexend|$maxindex|$indexpage~;
				}
				if ($pagenumb > $dropdisplaynum) {
					$pagedropindex1 .= qq~<option value="$indexstart|$indexend|$maxindex|$indexpage"$selected>$indxoption</option>\n~;
					$pagedropindex2 .= qq~<option value="$indexstart|$indexend|$maxindex|$indexpage"$selected>$indxoption</option>\n~;
				}
			}
			if ($pagenumb > $dropdisplaynum) {
				$pagedropindex1 .= qq~</select>\n</span>~;
				$pagedropindex2 .= qq~</select>\n</span>~;
			}
			$pagedropindex1 .= qq~<span id="ViewIndex1" class="droppageindex" style="height: 14px; visibility: hidden">&nbsp;</span>~;
			$pagedropindex2 .= qq~<span id="ViewIndex2" class="droppageindex" style="height: 14px; visibility: hidden">&nbsp;</span>~;
			$tmpmaxindex = $maxindex;
			if (substr($INFO{'start'}, 0, 3) eq "all") { $maxindex = $maxindex * $dropdisplaynum; }
			$prevpage          = $start - $tmpmaxindex;
			$nextpage          = $start + $maxindex;
			$pagedropindexpvbl = qq~<img src="$imagesdir/index_left0.gif" height="14" width="13" border="0" alt="" style="margin: 0px; display: inline; vertical-align: middle;" />~;
			$pagedropindexnxbl = qq~<img src="$imagesdir/index_right0.gif" height="14" width="13" border="0" alt="" style="margin: 0px; display: inline; vertical-align: middle;" />~;
			if ($start < $maxindex) { $pagedropindexpv .= qq~<img src="$imagesdir/index_left0.gif" height="14" width="13" border="0" alt="" style="display: inline; vertical-align: middle;" />~; }
			else { $pagedropindexpv .= qq~<img src="$imagesdir/index_left.gif" border="0" height="14" width="13" alt="$pidtxt{'02'}" style="display: inline; vertical-align: middle; cursor: pointer;" onclick="location.href=\\'$scripturl?board=$currentboard/$prevpage\\'" ondblclick="location.href=\\'$scripturl?board=$currentboard/0\\'" />~; }
			if ($nextpage > $lastptn) { $pagedropindexnx .= qq~<img src="$imagesdir/index_right0.gif" border="0" height="14" width="13" alt="" style="display: inline; vertical-align: middle;" />~; }
			else { $pagedropindexnx .= qq~<img src="$imagesdir/index_right.gif" height="14" width="13" border="0" alt="$pidtxt{'03'}" style="display: inline; vertical-align: middle; cursor: pointer;" onclick="location.href=\\'$scripturl?board=$currentboard/$nextpage\\'" ondblclick="location.href=\\'$scripturl?board=$currentboard/$lastptn\\'" />~; }
			$pageindex1 = qq~$pagedropindex1</span>~;
			$pageindex2 = qq~$pagedropindex2</span>~;

			$pageindexjs = qq~
<script language="JavaScript1.2" type="text/javascript">
<!-- 
	function SelDec(decparam, visel) {
		splitparam = decparam.split("|");
		var vistart = parseInt(splitparam[0]);
		var viend = parseInt(splitparam[1]);
		var maxpag = parseInt(splitparam[2]);
		var pagstart = parseInt(splitparam[3]);
		var allpagstart = parseInt(splitparam[3]);
		if(visel == 'xx' && decparam == '$pagejsindex') visel = '$tstart';
		var pagedropindex = '<table border="0" cellpadding="0" cellspacing="0"><tr>';
		for(i=vistart; i<=viend; i++) {
			if(visel == pagstart) pagedropindex += '<td class="titlebg" height="14" style="height: 14px; padding-left: 1px; padding-right: 1px; font-size: 9px; font-weight: bold;">' + i + '</td>';
			else pagedropindex += '<td height="14" class="droppages"><a href="$scripturl?board=$currentboard/' + pagstart + '">' + i + '</a></td>';
			pagstart += maxpag;
		}
		if (vistart != viend) {
			if(visel == 'all') pagedropindex += '<td class="titlebg" height="14" style="height: 14px; padding-left: 1px; padding-right: 1px; font-size: 9px; font-weight: normal;"><b>$pidtxt{"01"}</b></td>';
			else pagedropindex += '<td height="14" class="droppages"><a href="$scripturl?board=$currentboard/all-' + allpagstart + '">$pidtxt{"01"}</a></td>';
		}
		if(visel != 'xx') pagedropindex += '<td height="14" class="small" style="height: 14px; padding-left: 4px;">$pagedropindexpv$pagedropindexnx</td>';
		else pagedropindex += '<td height="14" class="small" style="height: 14px; padding-left: 4px;">$pagedropindexpvbl$pagedropindexnxbl</td>';
		pagedropindex += '</tr></table>';
		document.getElementById("ViewIndex1").innerHTML=pagedropindex;
		document.getElementById("ViewIndex1").style.visibility = "visible";
		document.getElementById("ViewIndex2").innerHTML=pagedropindex;
		document.getElementById("ViewIndex2").style.visibility = "visible";
		~;
			if ($pagenumb > $dropdisplaynum) {
				$pageindexjs .= qq~
		document.getElementById("decselector1").value = decparam;
		document.getElementById("decselector2").value = decparam;
		~;
			}
			$pageindexjs .= qq~
	}
	document.onload = SelDec('$pagejsindex', '$tstart');
	//-->
</script>
~;
		}
	}

	# Determine what category we are in.
	$catid = ${$uid.$currentboard}{'cat'};
	($cat, $catperms) = split(/\|/, $catinfo{"$catid"});
	&ToChars($cat);
	fopen(BRDTXT, "$boardsdir/$currentboard.txt") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.txt", 1);
	@threadlist = <BRDTXT>;
	fclose(BRDTXT);
	$threadcount = $#threadlist;

	if (-e "$vardir/attachments.txt" && -s "$vardir/attachments.txt") {
		fopen(ATT, "$vardir/attachments.txt");
		@attachmentlist = <ATT>;
		fclose(ATT);

		@temparr = ();
		$i       = 1;
		foreach $theatt (@attachmentlist) {
			($check, undef, undef, undef, undef, undef, undef, $checkimg, undef) = split(/\|/, $theatt, 9);
			$duped = 0;
			foreach $checkout (@temparr) {
				if ($checkout eq $check) {
					$duped = 1;
					$attachments{$check}++;
					if($checkimg =~ /(jpg|gif|bmp|png|jpeg)$/i) { $attachmentsimg{$check}++; }
				}
			}
			if ($duped == 0) {
				push(@temparr, $check);
				$attachments{$check} = $i;
				if($checkimg =~ /(jpg|gif|bmp|png|jpeg)$/i) { $attachmentsimg{$check} = $i; }
			}
		}
		undef @temparr;
	}


	# Mark current board as seen.
	&dumplog($currentboard);

	# Build a list of the board's moderators.
	$iammod = 0;
	if (scalar keys %moderators > 0) {
		if (scalar keys %moderators == 1) { $showmods = qq~($messageindex_txt{'298'}: ~; }
		else { $showmods = qq~($messageindex_txt{'63'}: ~; }
		while ($_ = each(%moderators)) {
			if ($username eq $_) { $iammod = 1; }
			$moderators{$_} = qq~$link{$_}~;
			$showmods .= qq~$moderators{$_}, ~;
		}
		$showmods =~ s/, \Z/)/;
	}
	if (scalar keys %moderatorgroups > 0) {
		&LoadUser($username);
		if (scalar keys %moderatorgroups == 1) { $showmodgroups = qq~($messageindex_txt{'298a'}: ~; }
		else { $showmodgroups = qq~($messageindex_txt{'63a'}: ~; }
		while ($mdgrps = each(%moderatorgroups)) {
			$tmpmodgrp = $moderatorgroups{$mdgrps};
			if (${$uid.$username}{'position'} == $tmpmodgrp) { $iammod = 1; }
			${$uid.$username}{'addgroups'} =~ s/\, /\,/g;
			(@memaddgrp) = split(/\,/, ${$uid.$username}{'addgroups'});
			foreach $memberaddgroups (@memaddgrp) {
				chomp $memberaddgroups;
				if ($memberaddgroups == $tmpmodgrp) { $iammod = 1; last; }
			}
			($thismodgrp, undef) = split(/\|/, $NoPost{$tmpmodgrp}, 2);
			$showmodgroups .= qq~$thismodgrp, ~;
		}
		$showmodgroups =~ s/, \Z/)/;
	}
	if ($showmodgroups ne "" && $showmods ne "") { $showmods .= qq~ - ~; }

	if ($numanns) { $countsticky = $numanns; }
	else { $countsticky = 0; }
	$countnosticky = 0;
	if ($numanns) { push(@stickythreadlist, @anns); }
	for ($i = 0; $i <= $threadcount; $i++) {
		my @array        = split(/\|/, $threadlist[$i]);
		my $threadstatus = pop(@array);                    #get only status
		my $mnum         = shift(@array);                  # get only number
		undef @array;
		if ($threadstatus =~ /s/i) {
			unless(!$iamadmin && !$iamgmod && !$iammod && $threadstatus =~ /h/i) {
				$stickythreadlist[$countsticky] = $threadlist[$i];
				$countsticky++;
			}
		} else {
			$nostickythreadlist[$countnosticky] = $threadlist[$i];
			$countnosticky++;
		}
	}

	if ($countsticky) { @threadlist = (@stickythreadlist, @nostickythreadlist); }
	@threads = splice(@threadlist, $start, $maxindex);
	chomp @threads;

	$stkynum = '';
	if ($start <= $#stickythreadlist) { $stkynum = scalar @stickythreadlist; }

	&LoadCensorList;

	# Print the header and board info.
	&ToChars($boardname);
	$curboardurl = $curposlinks ? qq~<a href="$scripturl?board=$currentboard" class="nav">$boardname</a>~ : $boardname;
	if ((($iammod && $modview == 1) || ($iamadmin && $adminview == 1) || ($iamgmod && $gmodview == 1)) && $sessionvalid == 1) {
		$yymain .= qq~<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>~;
	}

	my $homelink  = qq~<a href="$scripturl" class="nav">$mbname</a>~;
	my $catlink   = qq~<a href="$scripturl?catselect=$catid" class="nav">$cat</a>~;
	my $boardlink = qq~<a href="$scripturl?board=$currentboard" class="nav">$boardname</a>~;
	my $modslink  = qq~$showmods~;

	# check howmany col's must be spanned
	if ((($iamadmin && $adminview >= 1) || ($iamgmod && $gmodview >= 1) || ($iammod && $modview >= 1)) && $sessionvalid == 1) {
		$colspan = 8;
	} else {
		$colspan = 7;
	}

	if (!$iamguest) {
		$markalllink = qq~$menusep<a href="$scripturl?board=$INFO{'board'};action=markasread">$img{'markboardread'}</a>~;
		if ($enable_notification) {
			$notify_board = qq~$menusep<a href="$scripturl?action=boardnotify;board=$INFO{'board'}">$img{'notify'}</a>~;
		} else {
			$notify_board = "";
		}
	}

	if (&AccessCheck($currentboard, 1) eq "granted") {
		$postlink = qq~$menusep<a href="$scripturl?board=$INFO{'board'};action=post;title=StartNewTopic" rel="nofollow">$img{'newthread'}</a>~;
	}
	if (&AccessCheck($currentboard, 3) eq "granted") {
		$polllink = qq~$menusep<a href="$scripturl?board=$INFO{'board'};action=post;title=CreatePoll" rel="nofollow">$img{'createpoll'}</a>~;
	}

	if ((($iamadmin && $adminview == 3) || ($iamgmod && $gmodview == 3) || ($iammod && $modview == 3)) && $sessionvalid == 1) {

		if ($currentboard eq $annboard) {
			$adminlink = qq~<img src="$imagesdir/admin_move.gif" alt="$messageindex_txt{'132'}" border="0" /><img src="$imagesdir/admin_rem.gif" alt="$messageindex_txt{'54'}" border="0" />~;
		} else {
			$adminlink = qq~<img src="$imagesdir/locked.gif" alt="$messageindex_txt{'104'}" border="0" /><img src="$imagesdir/sticky.gif" alt="$messageindex_txt{'781'}" border="0" /><img src="$imagesdir/admin_move.gif" alt="$messageindex_txt{'132'}" border="0" /><img src="$imagesdir/admin_rem.gif" alt="$messageindex_txt{'54'}" border="0" />~;
		}
		$adminheader =~ s/<yabb admin>/$adminlink/g;
	} elsif ((($iamadmin && $adminview != 0) || ($iamgmod && $gmodview != 0) || ($iammod && $modview != 0)) && $sessionvalid == 1) {
		$adminlink = qq~$messageindex_txt{'2'}~;
		$adminheader =~ s/<yabb admin>/$adminlink/g;
	}
		$colspan2 = 7;
	if(${$uid.$currentboard}{'brate_enable'} && ${$uid.$currentboard}{'view_arate'} == 1 && $enable_ratings && $tviewrate) {
		$colspan2 = 8;
		$colspan = ++$colspan;
		$rating_title .= qq~<td class="titlebg" align="center">$mbcrate{'04'}</td>~;
		$messageindex_template =~ s/<yabb rating title>/$rating_title/g;
	}

	# check to display moderator column
	my $tmpstickyheader;
	if ($stkynum) {
		$stickyheader =~ s/<yabb colspan>/$colspan/g;
		$tmpstickyheader = $stickyheader;
	}

	# Begin printing the message index for current board.
	$counter = $start;
	my @logthreads = @threads;
	push(@logthreads, "$curboard--mark");
	&getlog(@logthreads);
	foreach (@threads) {
		($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/, $_);

		# Set thread class depending on locked status and number of replies.
		if ($mnum == "") { next; }
		$threadclass = 'thread';
		if    ($mstate =~ /h/i) { $threadclass = 'hide'; }
		elsif ($mstate =~ /l/i) { $threadclass = 'locked'; }
		elsif ($mreplies >= $VeryHotTopic) { $threadclass = 'veryhotthread'; }
		elsif ($mreplies >= $HotTopic)     { $threadclass = 'hotthread'; }
		elsif ($mstate == "")              { $threadclass = 'thread'; }

		if ($threadclass eq "hide" && ((!$iamadmin && !$iamgmod && !$iammod) || $sessionvalid == 0)) { next; }
		elsif ($threadclass eq 'hide' && $mstate =~ /s/i && $mstate !~ /l/i) { $threadclass = 'hidesticky'; }
		elsif ($threadclass eq 'hide' && $mstate =~ /l/i && $mstate !~ /s/i) { $threadclass = 'hidelock'; }
		elsif ($threadclass eq 'hide' && $mstate =~ /s/i && $mstate =~ /l/i) { $threadclass = 'hidestickylock'; }
		elsif ($threadclass eq 'locked' && $mstate =~ /s/i && $mstate !~ /h/i) { $threadclass = 'stickylock'; }
		elsif ($mstate =~ /s/i && $mstate !~ /h/i) { $threadclass = 'sticky'; }
		elsif ($mstate =~ /a/i && $mstate !~ /h/i) { $threadclass = 'announcement'; }
		### Start Sticky Shimmy Shuffle mod
		my $stickdir;
		if ($iammod || $iamadmin || $iamgmod) {
		if ($threadclass eq "sticky" || $threadclass eq "stickylock"){$stickdir = qq~&nbsp;&nbsp;<a href="$scripturl?action=rearrsticky;board=$currentboard;num=$mnum;direction=up"><font size="3"><b>&uarr;</b></font></a><a href="$scripturl?action=rearrsticky;board=$currentboard;num=$mnum;direction=down"><font size="3"><b>&darr;</b></font> </a>~;}
		elsif (($threadclass eq "announcement") && ($iamadmin || $iamgmod)){$stickdir = qq~&nbsp;&nbsp;<a href="$scripturl?action=rearrsticky;board=$annboard;num=$mnum;direction=up;oldboard=$currentboard;"><font size="3"><b>&uarr;</b></font></a><a href="$scripturl?action=rearrsticky;board=$annboard;num=$mnum;direction=down;oldboard=$currentboard;"><font size="3"><b>&darr;</b></font> </a>~;}}
		### End Sticky Shimmy Shuffle Mod

		if (!$iamguest && $max_log_days_old) {

			# Decide if thread should have the "NEW" indicator next to it.
			# Do this by reading the user's log for last read time on thread,
			# and compare to the last post time on the thread.
			$dlp  = $yyuserlog{$mnum}                 ? $yyuserlog{$mnum}                 : 0;
			$dlpb = $yyuserlog{"$currentboard--mark"} ? $yyuserlog{"$currentboard--mark"} : 0;
			$dlp  = $dlp > $dlpb                      ? $dlp                              : $dlpb;
			$threaddate = $mdate;
			if ($dlp < $threaddate && ($dlp > $max_log_days_old * 86400 || $dlp eq 0)) {
				if ($mstate =~ /a/i) {
					$new = qq~<a href="$scripturl?virboard=$currentboard;num=$mnum/new"><img src="$imagesdir/new.gif" alt="$messageindex_txt{'302'}" border="0"/></a>~;
				} else {
					$new = qq~<a href="$scripturl?num=$mnum/new"><img src="$imagesdir/new.gif" alt="$messageindex_txt{'302'}" border="0"/></a>~;
				}
			} elsif ($yyuserlog{"$mnum--unread"} && !$yyuserlog{$mnum}) {
				if ($mstate =~ /a/i) {
					$new = qq~<a href="$scripturl?virboard=$currentboard;num=$mnum/new"><img src="$imagesdir/new.gif" alt="$messageindex_txt{'302'}" border="0"/></a>~;
				} else {
					$new = qq~<a href="$scripturl?num=$mnum/new"><img src="$imagesdir/new.gif" alt="$messageindex_txt{'302'}" border="0"/></a>~;
				}
			} else {
				$new = '';
			}
		}

		$micon = qq~<img src="$imagesdir/$micon.gif" alt="" border="0" align="middle" />~;
		$mpoll = "";
		if (-e "$datadir/$mnum.poll") {
			$mpoll = qq~<b>$messageindex_polltxt{'15'}: </b>~;
			fopen(POLL, "$datadir/$mnum.poll");
			$poll_question = <POLL>;
			fclose(POLL);
			chomp $poll_question;
			(undef, $poll_locked, undef) = split(/\|/, $poll_question, 3);
			$micon = qq~$img{'pollicon'}~;
			if ($poll_locked) { $micon = $img{'polliconclosed'}; }
			elsif (!$iamguest && $max_log_days_old && $mdate > time - ($max_log_days_old * 86400)) {

				if ($dlp < $createpoll_date) {
					$micon = qq~$img{'polliconnew'}~;
				} else {
					fopen(POLLED, "$datadir/$mnum.polled");
					$polled = <POLLED>;
					fclose(POLLED);
					(undef, undef, undef, $vote_date, undef) = split(/\|/, $polled);
					if ($dlp < $vote_date) { $micon = qq~$img{'polliconnew'}~; }
				}
			}
		}

		# Load the current nickname of the account name of the thread starter.
		if ($musername ne 'Guest') {
			&LoadUser($musername);
			$registrationdate = ${$uid.$musername}{'regtime'};
			$threadstartdate  = $mnum;

		### Thread Start Date mod ###
			$threadstartdatestring = &timeformat($threadstartdate);

			if ((${$uid.$musername}{'regdate'} && $threadstartdate > $registrationdate) || ${$uid.$musername}{'status'} eq "Administrator" || ${$uid.$musername}{'status'} eq "Global Moderator") {
				$mname = qq~$link{$musername}<br />$threadstartdatestring~; ### Thread Start Date mod ###
			} else {
				$mname .= qq~ ($messageindex_txt{'470a'})~;
			}
		}
		elsif ($musername eq 'Guest'){
			$threadstartdate  = $mnum;
			$threadstartdatestring = &timeformat($threadstartdate);
		}
		### Thread Start Date mod end ###
		$msub =~ s/\A\[m\]/$maintxt{'758'}/;

		# Censor the subject of the thread.
		$msub = &Censor($msub);
		&ToChars($msub);

		# Build the page links list.
		$pages = '';
		if (int(($mreplies + 1) / $maxmessagedisplay) > 6) {
			$pages = qq~ <a href="$scripturl?num=$mnum/0#0">1</a>~;
			$pages .= qq~ <a href="$scripturl?num=$mnum/$maxmessagedisplay#$maxmessagedisplay">2</a>~;
			$endpage = int(($mreplies) / $maxmessagedisplay) + 1;
			$i       = ($endpage - 1) * $maxmessagedisplay;
			$j       = $i - $maxmessagedisplay;
			$k       = $endpage - 1;
			$tmpa    = $endpage - 2;
			$tmpb    = $j - $maxmessagedisplay;
			$pages .= qq~ <a href="$scripturl?action=pages;num=$mnum">...</a>~;
			$pages .= qq~ <a href="$scripturl?num=$mnum/$tmpb#$tmpb">$tmpa</a>~;
			$pages .= qq~ <a href="$scripturl?num=$mnum/$j#$j">$k</a>~;
			$pages .= qq~ <a href="$scripturl?num=$mnum/$i#$i">$endpage</a>~;
			$pages = qq~<br /><span class="small">&#171; $messageindex_txt{'139'} $pages <a href="$scripturl?num=$mnum;start=all">$pidtxt{'01'}</a> &#187;</span>~;
		} elsif ($mreplies + 1 > $maxmessagedisplay) {
			$tmpa = 1;
			for ($tmpb = 0; $tmpb < $mreplies + 1; $tmpb += $maxmessagedisplay) {
				$pages .= qq~<a href="$scripturl?num=$mnum/$tmpb#$tmpb">$tmpa</a>\n~;
				++$tmpa;
			}
			$pages =~ s/\n\Z//;
			$pages = qq~<br /><span class="small">&#171; $messageindex_txt{'139'} $pages <a href="$scripturl?num=$mnum;start=all">$pidtxt{'01'}</a> &#187;</span>~;
		}

		&MessageTotals("load", $mnum);
		$views      = ${$mnum}{'views'};
		$lastposter = ${$mnum}{'lastposter'};
		if ($lastposter =~ m~\AGuest-(.*)~) {
			$lastposter = $1;
		} else {
			&LoadUser($lastposter);
			$registrationdate = ${$uid.$lastposter}{'regtime'};

			$messagedate = ${$mnum}{'lastpostdate'};

			if ((${$uid.$lastposter}{'regdate'} && $messagedate > $registrationdate) || ${$uid.$lastposter}{'position'} eq "Administrator" || ${$uid.$lastposter}{'position'} eq "Global Moderator") { $lastposter = qq~$link{$lastposter}~; }
			else { $lastposter .= qq~ - $messageindex_txt{'470a'}~; }
		}
		$lastpostername = $lastposter || $messageindex_txt{'470'};
		$views = $views ? $views - 1 : 0;

		if (($stkynum && ($counter >= $stkynum)) && ($stkyshowed < 1)) {
			$nonstickyheader =~ s/<yabb colspan>/$colspan/g;
			$tmptempbar .= $nonstickyheader;
			$stkyshowed = 1;
		}

		# Check if the thread contains attachments and create a paper-clip icon if it does
		$temp_attachment = "";
		$temp_attachmentfile = "";
		$temp_attachmentimg = "";
		$count_attachfiles = 0;
		
		if (exists $attachments{$mnum}) {

			if (exists $attachmentsimg{$mnum}) {
				$count_attachfiles = $attachments{$mnum} - $attachmentsimg{$mnum};
				if($attachmentsimg{$mnum} == 1) { $attimgalttext = qq~$messageindex_txt{'3'} $attachmentsimg{$mnum} $messageindex_txt{'5'} $messageindex_txt{'5b'}~; } 
				else { $attimgalttext = qq~$messageindex_txt{'3'} $attachmentsimg{$mnum} $messageindex_txt{'4'} $messageindex_txt{'4b'}~; }

				if ($count_attachfiles > 0) {
					if($count_attachfiles == 1) { $attalttext = qq~$messageindex_txt{'3'} $count_attachfiles $messageindex_txt{'5'} $messageindex_txt{'5a'}~; } 
					else { $attalttext = qq~$messageindex_txt{'3'} $count_attachfiles $messageindex_txt{'4'} $messageindex_txt{'4a'}~; }
					$temp_attachmentfile = qq~<img src="$imagesdir/paperclip.gif" alt="$attalttext" />~;
				}
					
				$temp_attachmentimg = qq~&nbsp;<img src="$imagesdir/img2.gif" alt="$attimgalttext" />~;

			} else {
				if($attachments{$mnum} == 1) {	$attalttext = qq~$messageindex_txt{'3'} $attachments{$mnum} $messageindex_txt{'5'} $messageindex_txt{'5a'}~; } 
				else { $attalttext = qq~$messageindex_txt{'3'} $attachments{$mnum} $messageindex_txt{'4'} $messageindex_txt{'4a'}~; }				
				$temp_attachmentfile = qq~<img src="$imagesdir/paperclip.gif" alt="$attalttext" />~;
			}

			$temp_attachment = qq~$temp_attachmentfile$temp_attachmentimg~;
		}
if(!-e ("$RatesDir/$mnum.rate") && ${$uid.$currentboard}{'brate_enable'} && ${$uid.$currentboard}{'apply_arate'} == 1 && $enable_ratings && $mstate !~ /a/i  && $mstate !~ /l/i && $tviewrate) {
		if(!-e ("$vardir/rateitlist.txt")) {
			fopen(FILE, ">$vardir/rateitlist.txt", 1);
			print FILE "|1|1|1\n";
			fclose(FILE);
		}

		fopen(FILE, "$vardir/rateitlist.txt");
		@ratelist = <FILE>;
		$listnum = @ratelist;
		fclose(FILE);

		$namestart = "";
		$namestart .= qq($msub|$date|$mstate);
		$ratelink = qq~$scripturl?num=$mnum~;

		fopen( FILE, ">$RatesDir/$mnum.rate", 1);
		print FILE "$currentboard|$boardname\n";
		print FILE "$namestart\n";
		print FILE "\n";
		print FILE "0.00|0\n";
		print FILE "$ratelink\n";
		fclose(FILE);

		fopen(FILE, ">$vardir/rateitlist.txt", 1);
		foreach $currate (@ratelist) {
			chomp $currate;
			print FILE "$currate\n";
		}
		print FILE "$mnum|$username|$currentboard|$mstate\n";
		fclose(FILE);
}
	
if (${$uid.$currentboard}{'brate_enable'} && ${$uid.$currentboard}{'view_arate'} == 1 && $enable_ratings && $tviewrate) {
		@rateinfo = ();
		fopen(RATEFILEREAD,"$RatesDir/$mnum.rate");
		@rateinfo = <RATEFILEREAD>;
		$lines = @rateinfo;
		fclose(RATEFILEREAD);
		chomp @rateinfo;
		$raters = $lines - 5;
		($rating, $clicks) = split(/\|/,$rateinfo[3]);
		if($rating == 0) { $rating = "0.00" }
		$barrate = $rating * 10;
		$ratebar = "";
		$ratebar1 = "";
		$ratebar2 = "";
		$barchart = int($barrate);

		$ratebar2 .= qq~<td class="windowbg" align="right">~;
	
if ($mstate !~ /a/i && -e ("$RatesDir/$mnum.rate")) {
		
	if(${$uid.$currentboard}{'view_rategraph'} == 1) {

		if(${$uid.$currentboard}{'view_ratestar'} == 1) {
			if($barchart < 10) { $ratebar2 .= qq~<div style="display: block;"><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st00.gif" border="0" alt="" align="absmiddle" /></a></div>~; }
			elsif($barchart < 30) { $ratebar2 .= qq~<div style="display: block;"><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st01.gif" border="0" alt="" align="absmiddle" /></a></div>~; }
			elsif($barchart < 50) { $ratebar2 .= qq~<div style="display: block;"><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st02.gif" border="0" alt="" align="absmiddle" /></a></div>~; }
			elsif($barchart < 70) { $ratebar2 .= qq~<div style="display: block;"><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st03.gif" border="0" alt="" align="absmiddle" /></a></div>~; }
			elsif($barchart < 90) { $ratebar2 .= qq~<div style="display: block;"><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st04.gif" border="0" alt="" align="absmiddle" /></a></div>~; }
			else { $ratebar2 .= qq~<div style="display: block;"><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st05.gif" border="0" alt="" align="absmiddle" /></a></div>~; }
		} else {
			$barchart1 = 100 - $barchart;
			if ($barchart < 1) {
				$ratebar = "$ratebar";
			} else {
				$ratebar = qq~<img src="$modimgurl/RateIT/ratebar.gif" width="$barchart" height="10" alt="" border="0" align="absmiddle" />~;
			}
			if ($barchart > 99) {
				$ratebar1 = "$ratebar1";
			} else {
				$ratebar1 = qq~<img src="$modimgurl/RateIT/ratebar1.gif" width="$barchart1" height="10" alt="" border="0" align="absmiddle" />~;
			}
			$ratebar2 .= qq~<div style="display: block;"><a href="$scripturl?action=rateoverview;rateid=$mnum">$ratebar$ratebar1</a></font></div>~;
		}

	} else {

		if(${$uid.$currentboard}{'view_ratestar'} == 1) {
			if($barchart < 10) { $ratebar2 .= qq~<div style="display: block;"><span class="small">$rating<br /><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st00.gif" border="0" alt="" align="absmiddle" /></a><br />$ratetxt{'05'} $raters</span></div>~; }
			elsif($barchart < 30) { $ratebar2 .= qq~<div style="display: block;"><span class="small">$rating<br /><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st01.gif" border="0" alt="" align="absmiddle" /></a><br />$ratetxt{'05'} $raters</span></div>~; }
			elsif($barchart < 50) { $ratebar2 .= qq~<div style="display: block;"><span class="small">$rating<br /><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st02.gif" border="0" alt="" align="absmiddle" /></a><br />$ratetxt{'05'} $raters</span></div>~; }
			elsif($barchart < 70) { $ratebar2 .= qq~<div style="display: block;"><span class="small">$rating<br /><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st03.gif" border="0" alt="" align="absmiddle" /></a><br />$ratetxt{'05'} $raters</span></div>~; }
			elsif($barchart < 90) { $ratebar2 .= qq~<div style="display: block;"><span class="small">$rating<br /><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st04.gif" border="0" alt="" align="absmiddle" /></a><br />$ratetxt{'05'} $raters</span></div>~; }
			else { $ratebar2 .= qq~<div style="display: block;"><span class="small">$rating<br /><a href="$scripturl?action=rateoverview;rateid=$mnum"><img src="$modimgurl/RateIT/st05.gif" border="0" alt="" align="absmiddle" /></a><br />$ratetxt{'05'} $raters</span></div>~; }
		} else {
			$barchart1 = 100 - $barchart;
			if ($barchart < 1) {
				$ratebar = "$ratebar";
			} else {
				$ratebar = qq~<img src="$modimgurl/RateIT/ratebar.gif" width="$barchart" height="10" alt="" border="0" align="absmiddle" />~;
			}
			if ($barchart > 99) {
				$ratebar1 = "$ratebar1";
			} else {
				$ratebar1 = qq~<img src="$modimgurl/RateIT/ratebar1.gif" width="$barchart1" height="10" alt="" border="0" align="absmiddle" />~;
			}
				$ratebar2 .= qq~<div style="display: block;"><span class="small">$rating<br /><a href="$scripturl?action=rateoverview;rateid=$mnum">$ratebar$ratebar1</a><br />$ratetxt{'05'} $raters</span></div>~;
		}

	}
	
} else {
		$ratebar2 .= qq~&nbsp;~;
}
		$ratebar2 .= qq~</td>~;
}

		# Print the thread info.
		$mydate = &timeformat($mdate);
		if ((($iamadmin && $adminview == 3) || ($iamgmod && $gmodview == 3) || ($iammod && $modview == 3 && !$iamadmin && !$iamgmod)) && $sessionvalid == 1) {
			if ($currentboard eq $annboard) {
				$adminbar = qq~
		<input type="checkbox" name="moveadmin$mcount" class="windowbg" style="border: 0px;" value="$mnum" />
		<input type="checkbox" name="deleteadmin$mcount" class="windowbg" style="border: 0px;" value="$mnum" />
        	~;
			} elsif ($currentboard ne $annboard && $counter < @anns) {
				$adminbar = qq~&nbsp;~;
			} else {
				$adminbar = qq~
		<input type="checkbox" name="lockadmin$mcount" class="windowbg" style="border: 0px;" value="$mnum" />
		<input type="checkbox" name="stickadmin$mcount" class="windowbg" style="border: 0px;" value="$mnum" />
		<input type="checkbox" name="moveadmin$mcount" class="windowbg" style="border: 0px;" value="$mnum" />
		<input type="checkbox" name="deleteadmin$mcount" class="windowbg" style="border: 0px;" value="$mnum" />
        	~;
			}
			$admincol = $admincolumn;
			$admincol =~ s/<yabb admin>/$adminbar/g;
		} elsif ((($iamadmin && $adminview == 2) || ($iamgmod && $gmodview == 2) || ($iammod && $modview == 2 && !$iamadmin && !$iamgmod)) && $sessionvalid == 1) {
			if ($currentboard ne $annboard && $counter < @anns) {
				$adminbar = qq~&nbsp;~;
			} else {
				$adminbar = qq~<input type="checkbox" name="admin$mcount" class="windowbg" style="border: 0px;" value="$mnum" />~;
			}
			$admincol = $admincolumn;
			$admincol =~ s/<yabb admin>/$adminbar/g;
		} elsif ((($iamadmin && $adminview == 1) || ($iamgmod && $gmodview == 1) || ($iammod && $modview == 1 && !$iamadmin && !$iamgmod)) && $sessionvalid == 1) {
			if ($currentboard eq $annboard) {
				$adminbar = qq~
		<a href="$scripturl?action=movethread;thread=$mnum"><img src="$imagesdir/admin_move.gif" alt="$messageindex_txt{'132'}" border="0" /></a>&nbsp;
		<a href="$scripturl?action=removethread;thread=$mnum" onclick="return confirm('$messageindex_txt{'162'}')"><img src="$imagesdir/admin_rem.gif" alt="$messageindex_txt{'54'}" border="0" /></a>
        	~;
			} elsif ($currentboard ne $annboard && $counter < @anns) {
				$adminbar = qq~&nbsp;~;
			} else {
				$adminbar = qq~
		<a href="$scripturl?action=lock;thread=$mnum"><img src="$imagesdir/locked.gif" alt="$messageindex_txt{'104'}" border="0" /></a>&nbsp;
		<a href="$scripturl?action=sticky;thread=$mnum"><img src="$imagesdir/sticky.gif" alt="$messageindex_txt{'781'}" border="0" /></a>&nbsp;
		<a href="$scripturl?action=movethread;thread=$mnum"><img src="$imagesdir/admin_move.gif" alt="$messageindex_txt{'132'}" border="0" /></a>&nbsp;
		<a href="$scripturl?action=removethread;thread=$mnum" onclick="return confirm('$messageindex_txt{'162'}')"><img src="$imagesdir/admin_rem.gif" alt="$messageindex_txt{'54'}" border="0" /></a>
        	~;
			}
			$admincol = $admincolumn;
			$admincol =~ s/<yabb admin>/$adminbar/g;
		}
 
		my $threadpic = qq~<img src="$imagesdir/$threadclass.gif" alt=""/>~;

		if ($mstate =~ /a/i) {
			$msublink = qq~<table width="100%" cellborder="0" cellpadding="0" cellspacing="0"><tr><td><a href="$scripturl?virboard=$currentboard;num=$mnum">$msub</a></td><td align="right"><font size="1">$stickdir</font></td></tr></table>~;
		} else {
			$msublink = qq~<table width="100%" cellborder="0" cellpadding="0" cellspacing="0"><tr><td><a href="$scripturl?num=$mnum">$msub</a></td><td align="right"><font size="1">$stickdir</font></td></tr></table>~;
		}

		my $lastpostlink = qq~<a href="$scripturl?num=$mnum/$mreplies#$mreplies">$img{'lastpost'} $mydate</a>~;
		my $tempbar      = $threadbar;

		$tempbar =~ s/<yabb admin column>/$admincol/g;
		$tempbar =~ s/<yabb threadpic>/$threadpic/g;
		$tempbar =~ s/<yabb icon>/$micon/g;
		$tempbar =~ s/<yabb new>/$new/g;
		$tempbar =~ s/<yabb poll>/$mpoll/g;
		$tempbar =~ s/<yabb favorite>/$favicon{$mnum}/g;
		$tempbar =~ s/<yabb subjectlink>/$msublink/g;
		$tempbar =~ s/<yabb attachmenticon>/$temp_attachment/g;
		$tempbar =~ s/<yabb pages>/$pages/g;
		$tempbar =~ s/<yabb starter>/$mname/g;
		$tempbar =~ s/<yabb replies>/$mreplies/g;
		$tempbar =~ s/<yabb views>/$views/g;
		$tempbar =~ s/<yabb lastpostlink>/$lastpostlink/g;
		$tempbar =~ s/<yabb lastposter>/$lastpostername/g;
		$tempbar =~ s/<yabb replies>/$mreplies/g;
		$tempbar =~ s/<yabb rating column>/$ratebar2/g;
		$tempbar =~ s/<yabb favorite>/$favicon{$mnum}/g;
		$tmptempbar .= $tempbar;
		++$counter;
		$mcount++;
	}

	# Put a "no messages" message if no threads exisit - just a  bit more friendly...
	if (!$tmptempbar) {

		$tmptempbar = qq~
		<tr>
			<td class="windowbg2" valign="middle" align="center" colspan="$colspan"><br />$messageindex_txt{'841'}<br /><br /></td>
		</tr>
		~;
	}

	$colspanfooter = --$colspan;
	$subfooterbar =~ s/<yabb colspan2>/$colspanfooter/g;
	my $multiview = 0;
	my $tmptempfooter;
	if    ((($iamadmin && $adminview == 3) || ($iamgmod && $gmodview == 3) || ($iammod && $modview == 3 && !$iamadmin && !$iamgmod)) && $sessionvalid == 1) { $multiview = 3; }
	elsif ((($iamadmin && $adminview == 2) || ($iamgmod && $gmodview == 2) || ($iammod && $modview == 2 && !$iamadmin && !$iamgmod)) && $sessionvalid == 1) { $multiview = 2; }

	if ($multiview >= 2) {
		&moveto;
		if ($multiview eq '3') {
			$tempfooter    = $subfooterbar;
			$adminselector = qq~
				$messageindex_txt{'133'}: <select name="toboard">$boardlist</select><input type="submit" value="$messageindex_txt{'462'}" />
			~;
			if ($currentboard eq $annboard) {
				$admincheckboxes = qq~
				<input type="checkbox" name="moveall" value="" class="titlebg" style="border: 0px;" onclick="if (this.checked) checkAll(1); else uncheckAll(1);" />
				<input type="checkbox" name="deleteall" value="" class="titlebg" style="border: 0px;" onclick="if (this.checked) checkAll(2); else uncheckAll(2);" />
				<input type="hidden" name="fromboard" value="$currentboard" />
			~;
			} else {
				$admincheckboxes = qq~
				<input type="checkbox" name="lockall" value="" class="titlebg" style="border: 0px;" onclick="if (this.checked) checkAll(1); else uncheckAll(1);" />
				<input type="checkbox" name="stickall" value="" class="titlebg" style="border: 0px;" onclick="if (this.checked) checkAll(2); else uncheckAll(2);" />
				<input type="checkbox" name="moveall" value="" class="titlebg" style="border: 0px;" onclick="if (this.checked) checkAll(3); else uncheckAll(3);" />
				<input type="checkbox" name="deleteall" value="" class="titlebg" style="border: 0px;" onclick="if (this.checked) checkAll(4); else uncheckAll(4);" />
				<input type="hidden" name="fromboard" value="$currentboard" />
			~;
			}
			$tempfooter =~ s/<yabb admin selector>/$adminselector/g;
			$tempfooter =~ s/<yabb admin checkboxes>/$admincheckboxes/g;
		} elsif ($multiview eq '2') {
			$tempfooter = $subfooterbar;
			if ($currentboard eq $annboard) {
				$adminselector = qq~
				<input type="radio" name="action" value="delete" class="titlebg" style="border: 0px;" checked="checked" /> $messageindex_txt{'31'}
				<input type="radio" name="action" value="move" class="titlebg" style="border: 0px;" /> $messageindex_txt{'133'}: <select name="toboard">$boardlist</select>
				<input type="hidden" name="fromboard" value="$currentboard" />
				<input type="submit" value="$messageindex_txt{'462'}" />
			~;
			} else {
				$adminselector = qq~
				<input type="radio" name="action" value="lock" class="titlebg" style="border: 0px;" checked="checked" /> $messageindex_txt{'104'}
				<input type="radio" name="action" value="stick" class="titlebg" style="border: 0px;" /> $messageindex_txt{'781'}
				<input type="radio" name="action" value="delete" class="titlebg" style="border: 0px;" /> $messageindex_txt{'31'}
				<input type="radio" name="action" value="move" class="titlebg" style="border: 0px;" /> $messageindex_txt{'133'}: <select name="toboard">$boardlist</select>
				<input type="radio" name="action" value="move" class="titlebg" style="border: 0px;" /> $messageindex_txt{'133'}: <select name="toboard">$boardlist</select>
					~;
				}
				$adminselector .= qq~
				<input type="hidden" name="fromboard" value="$currentboard" />
				<input type="submit" value="$messageindex_txt{'462'}" />
			~;
			}
			$admincheckboxes = qq~
				<input type="checkbox" name="checkall" value="" class="titlebg" style="border: 0px;" onclick="if (this.checked) checkAll(0); else uncheckAll(0);" />
			~;
			$tempfooter =~ s/<yabb admin selector>/$adminselector/g;
			$tempfooter =~ s/<yabb admin checkboxes>/$admincheckboxes/g;
		}
	}
	$tmptempfooter .= $tempfooter;
	&jumpto;

$yabbicons = qq~
	<img src="$imagesdir/thread.gif" alt="" /> $messageindex_txt{'457'}<br />
	<img src="$imagesdir/sticky.gif" alt="" /> $messageindex_txt{'779'}<br />
	<img src="$imagesdir/locked.gif" alt="" /> $messageindex_txt{'456'}<br />
	<img src="$imagesdir/stickylock.gif" alt="" /> $messageindex_txt{'780'}<br />
~;
	if (($iamadmin || $iamgmod || $iammod) && $sessionvalid == 1) {
		$yabbadminicons = qq~<img src="$imagesdir/hide.gif" alt="" /> $messageindex_txt{'458'}<br />~;
		$yabbadminicons .= qq~<img src="$imagesdir/hidesticky.gif" alt="" /> $messageindex_txt{'459'}<br />~;
		$yabbadminicons .= qq~<img src="$imagesdir/hidelock.gif" alt="" /> $messageindex_txt{'460'}<br />~;
		$yabbadminicons .= qq~<img src="$imagesdir/hidestickylock.gif" alt="" /> $messageindex_txt{'461'}<br />~;
	}
$yabbadminicons .= qq~
	<img src="$imagesdir/announcement.gif" alt="" /> $messageindex_txt{'779a'}<br />
	<img src="$imagesdir/hotthread.gif" alt="" /> $messageindex_txt{'454'} $HotTopic $messageindex_txt{'454a'}<br />
	<img src="$imagesdir/veryhotthread.gif" alt="" /> $messageindex_txt{'455'} $VeryHotTopic $messageindex_txt{'454a'}<br />
~;

	&LoadAccess;

	if ($sboard{"$currentboard"} ne "") {
		$subboardlist = $sboard{"$currentboard"};
		@sblist = split(/\,/, $subboardlist);
		foreach $curboard (@sblist) {
			## now fill all the neccesary hashes to show all board index stuff ##
			chomp $curboard;
			$cat_boardcnt{$catid}++;
			my ($sboardname, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
			my $access = &AccessCheck($curboard, '', $boardperms);
			if (!$iamadmin && $access ne "granted" && $boardview != 1) {next;}
			push (@goodboards, "$catid|$curboard");
			push (@loadboards, $curboard);
		}
		if ($loadboards[0] ne "") {
			&BoardTotals("load",@loadboards);
			foreach $topboard (@loadboards) {
				@subboard_lists = split(/\,/, $sblist{"$topboard"});
				foreach $tbsb (@subboard_lists) {
					my ($boardname, $boardperms, $boardview) = split(/\|/, $board{"$tbsb"});
					my $access = &AccessCheck($tbsb, '', $boardperms);
					if (!$iamadmin && $access ne "granted" && $boardview != 1) { next; }
					push(@loadsubboards, $tbsb);
				}
			}
			if ($loadsubboards[0] ne "") { &BoardTotals("load",@loadsubboards); }
			&getlog(@goodboards);
			foreach $curboard (@loadboards) {
				chomp $curboard;
				$lastposttime = ${$uid.$curboard}{'lastposttime'};
				${$uid.$curboard}{'lastposttime'} = ${$uid.$curboard}{'lastposttime'} eq 'N/A' || ! ${$uid.$curboard}{'lastposttime'} ? $boardindex_txt{'470'} : ${$uid.$curboard}{'lastposttime'};
				if(${$uid.$curboard}{'lastposttime'} != 0){$lastposttime{$curboard} = &timeformat(${$uid.$curboard}{'lastposttime'});} else {$lastposttime{$curboard} = $boardindex_txt{'470'};}
				$lastpostrealtime{$curboard} = ${$uid.$curboard}{'lastposttime'} eq 'N/A' || ! ${$uid.$curboard}{'lastposttime'} ? '' : ${$uid.$curboard}{'lastposttime'};
				$lsreply{$curboard} = ${$uid.$curboard}{'lastreply'}+ 1;
				if( ${$uid.$curboard}{'lastposter'} =~ m~\AGuest-(.*)~ ) {
					${$uid.$curboard}{'lastposter'} = $1;
					$lastposterguest{$curboard} = 1;
				}
				${$uid.$curboard}{'lastposter'} = ${$uid.$curboard}{'lastposter'} eq 'N/A' || ! ${$uid.$curboard}{'lastposter'} ? $boardindex_txt{'470'} : ${$uid.$curboard}{'lastposter'};
				${$uid.$curboard}{'messagecount'} = ${$uid.$curboard}{'messagecount'} || 0;
				${$uid.$curboard}{'threadcount'} = ${$uid.$curboard}{'threadcount'} || 0;
				$totalmessagecount{"$curboard"} = ${$uid.$curboard}{'messagecount'};
				$totalthreadcount{"$curboard"} = ${$uid.$curboard}{'threadcount'};
				@subboard_lists = split(/\,/, $sblist{"$curboard"});
				foreach $subboard_list (@subboard_lists) {
					my ($subboard_name, $subboard_perms, $subboard_view) = split(/\|/, $board{"$subboard_list"});
					my $access = &AccessCheck($subboard_list, '', $subboard_perms);
					if (!$iamadmin && $access ne "granted" && $subboard_view != 1) {next;}
					$totalmessagecount{"$curboard"} += ${$uid.$subboard_list}{'messagecount'};
					$totalthreadcount{"$curboard"} += ${$uid.$subboard_list}{'threadcount'};
				}

				## determine the true last post on all the boards a user has access to ##
				if ($lastposttime > $lastthreadtime){
					$lsdatetime = &timeformat($lastposttime);
					$lsposter = ${$uid.$curboard}{'lastposter'};
					$lssub = ${$uid.$curboard}{'lastsubject'};
					&ToChars($lssub);
					$lspostid = ${$uid.$curboard}{'lastpostid'};
					$lsreply = ${$uid.$curboard}{'lastreply'};
					$lastthreadtime = $lastposttime;
				}
			}
			foreach my $boardinfo (@goodboards) {
				chomp $boardinfo;
				my ($testcat);
				($testcat,$curboard)=split(/\|/,$boardinfo);	

				if ($testcat ne $catid){next;}
				## as we fill the vars based on all boards we need to skip any cat already shown before ##

				if (${$uid.$curboard}{'ann'} == 1) {${$uid.$curboard}{'pic'} = "ann.gif";}
				if (${$uid.$curboard}{'rbin'} == 1) {${$uid.$curboard}{'pic'} = "recycle.gif";}
				($sboardname, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
				&ToChars($sboardname);
				$INFO{'zeropost'} = 0; $zero = "";
				## hide the actual global announcement board for all normal users but admins and gmods ##
				if ($annboard eq $curboard && !$iamadmin && !$iamgmod) {next;}
				## hide the actual recycle bin board for all normal users but admins ##
				if ($annboard eq $curboard && $iamguest && !$iamadmin) {next;}
				$sbdpic = ${$uid.$curboard}{'pic'};
				$bddescr = ${$uid.$curboard}{'description'};
				&ToChars($bddescr);
				$bdmods = ${$uid.$curboard}{'mods'};
				$bdmods =~ s/\, /\,/g;
				$bdmods =~ s/\ /\,/g;
				%moderators = ();
				foreach $curuser (split(/\,/, $bdmods)) {
					&LoadUser($curuser);
					$moderators{$curuser} = ${$uid.$curuser}{'realname'};
				}
				$showsbmods = '';
				if(scalar keys %moderators == 1) { $showsbmods = qq~$boardindex_txt{'298'}: ~; }
				elsif(scalar keys %moderators != 0) { $showsbmods = qq~$boardindex_txt{'63'}: ~; }
				while($tmpa = each(%moderators)) {
					$showsbmods .= qq~$link{$tmpa}, ~;
				}
				$showsbmods =~ s/, \Z//;

				&LoadUser($username);
				$bdmodgroups = ${$uid.$curboard}{'modgroups'};
				$bdmodgroups =~ s/\, /\,/g;
				%moderatorgroups = ();
				foreach $curgroup (split(/\,/, $bdmodgroups)) {
					if (${$uid.$username}{'position'} eq $curgroup) { $iammod = 1; }
					foreach $memberaddgroups (split(/\, /, ${$uid.$username}{'addgroups'})) {
						chomp $memberaddgroups;
						if ($memberaddgroups eq $curgroup) { $iammod = 1; last; }
					}
					($thismodgrp, undef) = split(/\|/, $NoPost{$curgroup}, 2);
					$moderatorgroups{$curgroup} = $thismodgrp;
				}

				$showsbmodgroups = '';
				if(scalar keys %moderatorgroups == 1) { $showsbmodgroups = qq~$boardindex_txt{'298a'}: ~; }
				elsif(scalar keys %moderatorgroups != 0) { $showsbmodgroups = qq~$boardindex_txt{'63a'}: ~; }
				while($tmpa = each(%moderatorgroups)) {
					$showsbmodgroups .= qq~$moderatorgroups{$tmpa}, ~;
				}
				$showsbmodgroups =~ s/, \Z//;

				if ($sboard{"$curboard"} ne "") {
					my @subboard = split(/\,/, $sboard{"$curboard"});
					$commacount = 1;
					$subboardlist = "";
					foreach $sub (@subboard) {
						my ($subboard_name, $subboard_perms, $subboard_view) = split(/\|/, $board{"$sub"});
						my $access = &AccessCheck($sub, '', $subboard_perms);
						if (!$iamadmin && $access ne "granted" && $subboard_view != 1) {next;}
						if ($commacount++ == 1) {
							$subboardlist .= qq~<a href="$scripturl?board=$sub" class="nav">$subboard_name</a>~;
						} else {
							$subboardlist .= qq~, <a href="$scripturl?board=$sub" class="nav">$subboard_name</a>~;
						}
					}
					if ( $subboardlist ne "" ) {
						$subcount = @subboard;
						if ($subcount == 1) { $subboards = "$subboard_txt{'6'}: $subboardlist"; }
						else {$subboards = "$subboard_txt{'7'}: $subboardlist"; }
					} else { $subboards = ""; }
				} else { $subboards = ""; }

				if($showsbmodgroups eq "" && $showsbmods eq "" && $subboards eq "") { $subboards = qq~<br />~; }
				if($showsbmodgroups eq "" && $showsbmods ne "" && $subboards ne "") { $showsbmods .= qq~<br />~; }
				if($showsbmodgroups ne "" && $showsbmods ne "" && $subboards eq "") { $showsbmods .= qq~<br />~; }
				if($showsbmodgroups ne "" && $showsbmods eq "" && $subboards ne "") { $showsbmodgroups .= qq~<br />~; }
				if($showsbmodgroups ne "" && $showsbmods ne "" && $subboards ne "") { $showsbmods .= qq~<br />~; $showsbmodgroups .= qq~<br />~; }

				my $dlp = $yyuserlog{$curboard} ? $yyuserlog{$curboard} : 0;
				if( $max_log_days_old && ${$uid.$curboard}{'lastposttime'} ne $boardindex_txt{'470'} && !$iamguest && $dlp < $lastpostrealtime{$curboard} && ($dlp>$max_log_days_old*86400 || $dlp eq 0)) {
					$new = qq~<img src="$imagesdir/on.gif" alt="$boardindex_txt{'333'}" border="0" />~;
				}
				else { $new = qq~<img src="$imagesdir/off.gif" alt="$boardindex_txt{'334'}" border="0" />~; }
				@subboard_lists = split(/\,/, $sblist{"$curboard"});
				foreach $subboardlist (@subboard_lists) {
					my ($subboard_name, $subboard_perms, $subboard_view) = split(/\|/, $board{"$subboardlist"});
					my $access = &AccessCheck($subboard_list, '', $subboard_perms);
					if (!$iamadmin && $access ne "granted" && $subboard_view != 1) {next;}
					my $dlp = $yyuserlog{$subboardlist} ? $yyuserlog{$subboardlist} : 0;
					$lastpostrealtime{$subboardlist} = ${$uid.$subboardlist}{'lastposttime'} eq 'N/A' || ! ${$uid.$subboardlist}{'lastposttime'} ? '' : ${$uid.$subboardlist}{'lastposttime'};
					if( $max_log_days_old && ${$uid.$subboardlist}{'lastposttime'} ne $boardindex_txt{'470'} && !$iamguest && $dlp < $lastpostrealtime{$subboardlist} && ($dlp>$max_log_days_old*86400 || $dlp eq 0)) {
						$new = qq~<img src="$imagesdir/on.gif" alt="$boardindex_txt{'333'}" border="0" />~; last;
					}
				}
				if (${$uid.$curboard}{'ann'} == 1) {$new = qq~<img src="$imagesdir/ann.gif" alt="" border="0" />~;}
				if (${$uid.$curboard}{'rbin'} == 1) {$new = qq~<img src="$imagesdir/recycle.gif" alt="" border="0" />~;}
				$lastposter = ${$uid.$curboard}{'lastposter'};
				unless( $lastposterguest{$curboard} || ${$uid.$curboard}{'lastposter'} eq $boardindex_txt{'470'} ) {
					&LoadUser($lastposter);
					$registrationdate = ${$uid.$lastposter}{'regtime'};

					# No Need to open up each threadid.txt JUST to get last post time..
					# It's stored in forum.totals!
					#fopen (MNUM, "$datadir/${$uid.$curboard}{'lastpostid'}.txt");
					#@threadlist = <MNUM>; 
					#($dummy, $dummy, $dummy, $messagedate, $dummy) =  split(/\|/, $threadlist[${$uid.$curboard}{'lastreply'}],5);
					#fclose (MNUM);
						$messagedate = ${$uid.$curboard}{'lastposttime'};
						if((${$uid.$lastposter}{'regdate'} && $messagedate > $registrationdate) || ${$uid.$lastposter}{'status'} eq "Administrator" || ${$uid.$lastposter}{'status'} eq "Global Moderator") { 
						     $lastposter = qq~$link{$lastposter}~;
						}
					else { $lastposter .= qq~ - $boardindex_txt{'470a'}~; }
				}
				${$uid.$curboard}{'lastposter'} ||= $boardindex_txt{'470'};
				${$uid.$curboard}{'lastposttime'} ||= $boardindex_txt{'470'};

				if ($sbdpic =~ /\//i) {$sbdpic = qq~ <img src="$sbdpic" alt="" border="0" align="middle" /> ~;}
				elsif ($sbdpic) {$sbdpic = qq~ <img src="$imagesdir/$sbdpic" alt="" border="0" align="middle" /> ~;}

				my $templateblock = $subboardblock;
				if (${$uid.$curboard}{'lastreply'} ne "") {
					$lastpostlink = qq~<a href="$scripturl?num=${$uid.$curboard}{'lastpostid'}/${$uid.$curboard}{'lastreply'}#${$uid.$curboard}{'lastreply'}">$img{'lastpost'}</a> $lastposttime{$curboard}~;
				} else {
					$lastpostlink = qq~$img{'lastpost'} $boardindex_txt{'470'}~;
				}

				if(!$topiccut){$topiccut = 15;}
				my $lasttopictxt = ${$uid.$curboard}{'lastsubject'};
				$lasttopictxt =~ s/\A\[m\]/$maintxt{'758'}/;

				&LoadCensorList;	# Load Censor List
				# Censor subjects
				$lasttopictxt = &Censor($lasttopictxt);
				&ToChars($lasttopictxt);

				$convertstr = $lasttopictxt;
				$convertcut = $topiccut;
				&FromHTML($convertstr);
				&CountChars;
				my $lasttopictxt = $convertstr;
				&ToChars($lasttopictxt);

				if ($cliped){$lasttopictxt .= "...";}

				$lasttopictxt =~ s/  / \&nbsp;/g;
				$lasttopictxt =~ s/</&lt;/g;
				$lasttopictxt =~ s/>/&gt;/g;
				$lasttopictxt =~ s/\|/\&#124;/g;

				# Determine last post in subboards
				if ($sboard{"$curboard"} ne "") {
					$sblastpost = 0;
					@allsboards = split(/\,/, $sblist{"$curboard"});
					foreach $sb (@allsboards) {
						my ($sboardname, $sboardperms, $sboardview) = split(/\|/, $board{"$sb"});
						my $access = &AccessCheck($sb, '', $sboardperms);
						if (!$iamadmin && $access ne "granted" && $sboardview != 1) { next; }

						(@sbparents) = split(/\|/, $pboards{"$sb"});
						my ($spboardname, $spboardperms, $spboardview) = split(/\|/, $board{"$sbparents[-1]"});
						my $parentaccess = &AccessCheck("$sbparents[-1]", '', $spboardperms);
						if (!$iamadmin && $access ne "granted" && $parentaccess ne "granted") { next; }

						if (${$uid.$sb}{'lastposttime'} eq "") { next; }
						if (!$iammodhere && !$iamadmin && !$iamgmod) {
							fopen(MNUM, "$boardsdir/$sb.txt");
							@threadlist = <MNUM>;
							fclose(MNUM);
							my (@messarr) = split(/\|/, $threadlist[0]);
							$messagestate = pop(@messarr);
							if ($messagestate =~ /h/i) {
								${$uid.$sb}{'lastpostid'}   = "";
								${$uid.$sb}{'lastsubject'}  = "";
								${$uid.$sb}{'lastreply'}    = "";
								${$uid.$sb}{'lastposter'}   = qq~$boardindex_txt{'470'}~;
								${$uid.$sb}{'lastposttime'} = 0;
								$lastposttime{$sb} = qq~$boardindex_txt{'470'}~;
								for ($i = 1; $i < @threadlist; $i++) {
									($messageid, $messagesubject, undef, undef, undef, undef, undef, undef, $messagestate) = split(/\|/, $threadlist[$i]);
									if ($messagestate !~ /h/i) {
										fopen(MDATA, "$datadir/$messageid.ctb");
										@threaddata = <MDATA>;
										fclose(MDATA);
										chomp @threaddata;
										${$uid.$sb}{'lastpostid'}   = $messageid;
										${$uid.$sb}{'lastsubject'}  = $messagesubject;
										${$uid.$sb}{'lastreply'}    = $threaddata[1];
										${$uid.$sb}{'lastposter'}   = $threaddata[3];
										${$uid.$sb}{'lastposttime'} = $threaddata[4];
										$lastposttime{$sb} = &timeformat($threaddata[4]);
										last;
									}
								}
							}
						}
						if (${$uid.$sb}{'lastposttime'} > $sblastpost) {
							$sbdatetime     = $lastposttime{$sb};
							$sblastposter   = ${$uid.$sb}{'lastposter'};
							$sblastpostsub  = ${$uid.$sb}{'lastsubject'};
							$sblastpostid   = ${$uid.$sb}{'lastpostid'};
							$sblastreply    = ${$uid.$sb}{'lastreply'};
							$sblastpost     = ${$uid.$sb}{'lastposttime'};
							$sblastpostbd   = $sb;
						}
					}
					$sblastposter = ${$uid.$sblastpostbd}{'lastposter'};
					$sblastposter =~ s~\AGuest-(.*)~$1~i;

					if (${$uid.$sblastpostbd}{'lastposttime'} != 0) { $lastposttime{$sblastpostbd} = &timeformat(${$uid.$sblastpostbd}{'lastposttime'}); }
					else { $lastposttime{$sblastpostbd} = $boardindex_txt{'470'}; }

					unless ($lastposterguest{$sblastpostbd} || ${$uid.$sblastpostbd}{'lastposter'} eq $boardindex_txt{'470'}) {
						&LoadUser($sblastposter);
						$registrationdate = ${$uid.$sblastposter}{'regtime'};

						$sbmessagedate = ${$uid.$sblastpostbd}{'lastposttime'};

						if ((${$uid.$sblastposter}{'regdate'} && $sbmessagedate > $registrationdate) || ${$uid.$sblastposter}{'status'} eq "Administrator" || ${$uid.$sblastposter}{'status'} eq "Global Moderator") {
							$sblastposter = qq~$link{$sblastposter}~;
						} else {
							$sblastposter .= qq~ - $boardindex_txt{'470a'}~;
						}
					}
					${$uid.$sblastpostbd}{'lastposter'}   ||= $boardindex_txt{'470'};
					${$uid.$sblastpostbd}{'lastposttime'} ||= $boardindex_txt{'470'};
					if (!$topiccut) { $topiccut = 15; }
					my $sblasttopictxt = ${$uid.$sblastpostbd}{'lastsubject'};
					$sblasttopictxt =~ s/\A\[m\]/$maintxt{'758'}/;

					# Censor the subject
					&LoadCensorList;
					$sblasttopictxt = &Censor($sblasttopictxt);
					$sbfulltopictext = qq~$sblasttopictxt~;

					if (${$uid.$sblastpostbd}{'lastreply'} ne "") {
						$sblastpostlink = qq~<a href="$scripturl?num=${$uid.$sblastpostbd}{'lastpostid'}/${$uid.$sblastpostbd}{'lastreply'}#${$uid.$sblastpostbd}{'lastreply'}">$img{'lastpost'}</a> $lastposttime{$sblastpostbd}~;
					} else {
						$sblastpostlink = qq~$img{'lastpost'} $boardindex_txt{'470'}~;
					}

					$convertstr = $sblasttopictxt;
					$convertcut = $topiccut;
					&FromHTML($convertstr);
					&CountChars;
					my $sblasttopictxt = $convertstr;
					&ToChars($sblasttopictxt);
					&ToChars($sbfulltopictext);

					if ($cliped) { $sblasttopictxt .= "..."; }

					$sblasttopictxt =~ s/  / \&nbsp;/g;
					$sblasttopictxt =~ s/</&lt;/g;
					$sblasttopictxt =~ s/>/&gt;/g;
					$sblasttopictxt =~ s/\|/\&#124;/g;

					$sbfulltopictext =~ s/</&lt;/g;
					$sbfulltopictext =~ s/>/&gt;/g;
					$sbfulltopictext =~ s/\|/\&#124;/g;

					$sblasttopicsubject = $sblasttopictxt;
				}

				if ($sboard{"$curboard"} ne "" && $sblastpost > ${$uid.$curboard}{'lastposttime'}) {
					$lasttopiclink = qq~<a href="$scripturl?num=${$uid.$sblastpostbd}{'lastpostid'}/${$uid.$sblastpostbd}{'lastreply'}#${$uid.$sblastpostbd}{'lastreply'}" title="$sbfulltopictext">$sblasttopicsubject</a>~;
					$lastposter = $sblastposter;
					$lastpostlink = $sblastpostlink;
				} else {
					$lasttopiclink = qq~<a href="$scripturl?num=${$uid.$curboard}{'lastpostid'}/${$uid.$curboard}{'lastreply'}#${$uid.$curboard}{'lastreply'}" title="$fulltopictext">$lasttopictxt</a>~;
				}

				if(${$uid.$curboard}{'threadcount'}<0){${$uid.$curboard}{'threadcount'} = 0;}
				if(${$uid.$curboard}{'messagecount'}<0){${$uid.$curboard}{'messagecount'} = 0;}
				$templateblock =~ s/<yabb boardanchor>/$curboard/g;
				$templateblock =~ s/<yabb boardurl>/$scripturl\?board\=$curboard/g;
				$templateblock =~ s/<yabb new>/$new/g;
				$templateblock =~ s/<yabb sboardpic>/$sbdpic/g;
				$templateblock =~ s/<yabb boardname>/$sboardname/g;
				$templateblock =~ s/<yabb boarddesc>/$bddescr/g;
				$templateblock =~ s/<yabb sbmoderators>/$showsbmods$showsbmodgroups/g;
				$templateblock =~ s/<yabb subboards>/$subboards/g;
				$templateblock =~ s/<yabb threadcount>/$totalthreadcount{"$curboard"}/g;
				$templateblock =~ s/<yabb messagecount>/$totalmessagecount{"$curboard"}/g;
				$templateblock =~ s/<yabb lastpostlink>/$lastpostlink/g;
				$templateblock =~ s/<yabb lastposter>/$lastposter/g;
				$templateblock =~ s/<yabb lasttopiclink>/$lasttopiclink/g;

				$subblock .= $templateblock;
			}

			$showsubboards = "$subboardtitle$subboardheader$subblock$subboardfooter";
		}
	} else { $showsubboards = ""; }
	if ($pboard{"$currentboard"} ne "") {
		my @parents = ();
		@parents = split(/\|/, $pboard{"$currentboard"});
		$parentboards = "";
		foreach $parent (@parents) {
			($parent_name, $trash, $trash) = split(/\|/, $board{"$parent"});
			$parentboards .= qq~<a href="$scripturl?board=$parent" class="nav">$parent_name</a>$parentseparator~;
		}
	} else { $parentboards = ""; }
	#template it
	$template_mods = qq~$modslink$showmodgroups~;
	if ($template_mods) { $template_mods = qq~<br />$template_mods~; }
	### Start Message Index with Board Picture mod
	if ($bdpic =~ /\//i) { $bdpic = qq~ <img src="$bdpic" alt="" border="0" align="middle" /> ~; }
	elsif ($bdpic) { $bdpic = qq~ <img src="$imagesdir/$bdpic" alt="" border="0" align="middle" /> ~; }
	### End Message Index with Board Picture Mod

	$messageindex_template =~ s/<yabb home>/$homelink/g;
	$messageindex_template =~ s/<yabb category>/$catlink/g;
	$messageindex_template =~ s/<yabb parentboards>/$parentboards/g;
	$messageindex_template =~ s/<yabb board>/$boardlink/g;
	$messageindex_template =~ s/<yabb moderators>/$template_mods/g;
	### Start Message Index with Board Picture mod
	$messageindex_template =~ s/<yabb boardpic>/$bdpic/g;
	### End Message Index with Board Picture Mod
	$messageindex_template =~ s/<yabb subboardblock>/$showsubboards/g;
	if ($ShowBDescrip && $bdescrip ne "") {
		&ToChars($bdescrip);
		$boarddescription      =~ s/<yabb boarddescription>/$bdescrip/g;
		$messageindex_template =~ s/<yabb description>/$boarddescription/g;
	} else {
		$messageindex_template =~ s/<yabb description>//g;
	}
	$messageindex_template =~ s/<yabb colspan>/$colspan/g;

	$topichandellist       =~ s/<yabb notify button>/$notify_board/g;
	$topichandellist       =~ s/<yabb markall button>/$markalllink/g;
	$topichandellist       =~ s/<yabb new post button>/$postlink/g;
	$topichandellist       =~ s/<yabb new poll button>/$polllink/g;
	$topichandellist       =~ s/\Q$menusep//i;
	$messageindex_template =~ s/<yabb topichandellist>/$topichandellist/g;

	$messageindex_template =~ s/<yabb pageindex top>/$pageindex1/g;
	$messageindex_template =~ s/<yabb pageindex bottom>/$pageindex2/g;

	if ((($iamadmin && $adminview == 3) || ($iamgmod && $gmodview == 3) || ($iammod && $modview == 3 && !$iamadmin && !$iamgmod)) && $sessionvalid == 1) {
		$messageindex_template =~ s/<yabb admin column>/$adminheader/g;
	} elsif ((($iamadmin && $adminview != 0) || ($iamgmod && $gmodview != 0) || ($iammod && $modview != 0 && !$iamadmin && !$iamgmod)) && $sessionvalid == 1) {
		$messageindex_template =~ s/<yabb admin column>/$adminheader/g;
	} else {
		$messageindex_template =~ s/<yabb admin column>//g;
	}

	if ((($iamadmin && $adminview >= 2) || ($iamgmod && $gmodview >= 2) || ($iammod && $modview >= 2 && !$iamadmin && !$iamgmod)) && $sessionvalid == 1) {
		$formstart = qq~<form name="multiadmin" action="$scripturl?board=$currentboard;action=multiadmin" method="post" style="display: inline">~;
		$formend   = qq~<input type="hidden" name="allpost" value="$INFO{'start'}" /></form>~;
		$messageindex_template =~ s/<yabb modupdate>/$formstart/g;
		$messageindex_template =~ s/<yabb modupdateend>/$formend/g;
	} else {
		$messageindex_template =~ s/<yabb modupdate>//g;
		$messageindex_template =~ s/<yabb modupdateend>//g;
	}
	if ($tmpstickyheader) {
		$messageindex_template =~ s/<yabb stickyblock>/$tmpstickyheader/g;
	} else {
		$messageindex_template =~ s/<yabb stickyblock>//g;
	}
	$messageindex_template =~ s/<yabb threadblock>/$tmptempbar/g;
	if ($tmptempfooter) {
		$messageindex_template =~ s/<yabb adminfooter>/$tmptempfooter/g;
	} else {
		$messageindex_template =~ s/<yabb adminfooter>//g;
	}
	$messageindex_template =~ s/<yabb forumjump>/$selecthtml/g;
	$messageindex_template =~ s/<yabb icons>/$yabbicons/g;
	$messageindex_template =~ s/<yabb admin icons>/$yabbadminicons/g;
	$messageindex_template =~ s/<yabb access>/$accesses/g;
	$yymain .= qq~
	$messageindex_template
	$pageindexjs
	~;

	if ((($iamadmin && $adminview >= 2) || ($iamgmod && $gmodview >= 2) || ($iammod && $modview >= 2 && !$iamadmin && !$iamgmod)) && $sessionvalid == 1) {
		if ((($iamadmin && $adminview == 3) || ($iamgmod && $gmodview == 3) || ($iammod && $modview == 3 && !$iamadmin && !$iamgmod)) && $sessionvalid == 1) { $offset = "7"; }
		else { $offset = "8"; }

		if ($currentboard eq $annboard) { $modul = 2; $offset = ($offset - 2); }
		else { $modul = 4; }

		if ($sessionvalid == 1) {
			$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
	<!-- Begin
		function checkAll(j) {
  			for (var i = 0; i < document.multiadmin.elements.length - $offset; i++) {
  				if(document.multiadmin.elements[i].name != "subfield" && document.multiadmin.elements[i].name != "msgfield") {
					if (j == 0 ) {document.multiadmin.elements[i].checked = true;}
					if (j != 0 && (i % $modul) == (j - 1))  {document.multiadmin.elements[i].checked = true;}
    			}
  			}
		}
		function uncheckAll(j) {
  			for (var i = 0; i < document.multiadmin.elements.length - $offset; i++) {
  				if(document.multiadmin.elements[i].name != "subfield" && document.multiadmin.elements[i].name != "msgfield") {
					if (j == 0 ) {document.multiadmin.elements[i].checked = false;}
					if (j != 0 && (i % $modul) == (j - 1))  {document.multiadmin.elements[i].checked = false;}
		    	}
  			}
		}
	//-->
</script>
			~;
		}
	}

### Quick Reply Box ###
LoadLanguage("Post");
	# MBCO2 Post access check
	if ($start_users{$currentboard} || $start_groups{$currentboard}) {
		my $access = &AccessCheck($currentboard, 1) || "";
		if ($access eq "denied") {$enable_quickpost = 0;}
	}
	if ($enable_guestposting == 0 && $iamguest){
	$enable_quickpost = 0;
	}
	if ($enable_quickpost == 1) {
$yymain .= qq~
<script language="JavaScript1.2" src="$postjspath" type="text/javascript"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--
var postas = '$post';
var namefield = '$realname';
var mailfield = '$realemail';
function checkForm(theForm) {
if (navigator.appName == "Microsoft Internet Explorer") { theForm.message.createTextRange().execCommand("Copy"); }
if (theForm.subject.value == "") { alert("$post_txt{'77'}"); theForm.subject.focus(); return false }
if (postas == "imsend") { if (theForm.to.value == "") { alert("$post_txt{'752'}"); theForm.to.focus(); return false } }
else {
	if (namefield == "") {
		if (theForm.name.value == "" || theForm.name.value == "_" || theForm.name.value == " ") { alert("$post_txt{'75'}"); theForm.name.focus(); return false }
		if (theForm.name.value.length > 25)  { alert("$post_txt{'568'}"); theForm.name.focus(); return false }
	}
	if (mailfield == "") {
		if (theForm.email.value == "") { alert("$post_txt{'76'}"); theForm.email.focus(); return false }
		if (! checkMailaddr(theForm.email.value)) { alert("$post_txt{'500'}"); theForm.email.focus(); return false }
	}
}
if (theForm.message.value == "") { alert("$post_txt{'78'}"); theForm.message.focus(); return false }
return true
}
//-->
</script>
~;

$yymain .= qq~
<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
<form action="$scripturl?board=$currentboard;action=post2" method="post" name="postmodify" enctype="multipart/form-data" onsubmit="if(!checkForm(this)) {return false} else {return submitproc()}"><input type="hidden" name="threadid" value="" />
<input type="hidden" name="icon" value="xx" />
<table border=0 width="80%" cellspacing="1" cellpadding="4" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td align="center" class="titlebg" bgcolor="$color{'titlebg'}"><font size="2" class="text1" color="$color{'titletext'}"><b>$qrb_txt{'1'}</b></font></td>
  </tr>
  <tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
      <table width="100%" cellpadding="4" cellspacing="0">
        <tr>
          <td valign="top" width="23%"><font size="2"><b>$post_txt{'70'}:</b></font></td>
          <td><font size="2"><input type="text" name="subject" value="" size="40" style="width:100%" /></td>
        </tr>~;
		if ($enable_quicksmilies == 1) {
			if ($smiliestyle eq 1){$smiliewinlink = "$scripturl?action=smilieput";} else { $smiliewinlink = "$scripturl?action=smilieindex";}
			$moresmilieslist = ""; 
			$more_smilie_array = ""; 
			$i=0; 
			if ($showadded eq 1){ # show added smilies on smiley bar
				while($SmilieURL[$i]) { 
					if ($SmilieURL[$i]=~ /\//i) {$tmpurl = $SmilieURL[$i];} else {$tmpurl = qq~$defaultimagesdir/$SmilieURL[$i]~;}
					$moresmilieslist .= qq~      document.write("<img src='$tmpurl' align='bottom' alt='$SmilieDescription[$i]' border='0' onclick='javascript:MoreSmilies($i)' style='cursor:hand' />$SmilieLinebreak[$i] ");\n~; 
					$tmpcode = $SmilieCode[$i];
					$tmpcode =~ s/\&quot;/"+'"'+"/g;
					&FromHTML($tmpcode);
					$tmpcode =~ s/&#36;/\$/g;
					$tmpcode =~ s/&#64;/\@/g;
					$more_smilie_array .= qq~" $tmpcode", ~; 
					$i++; 
				} 
			}
			if ($showsmdir eq 1){ # show auto smilies on smiley bar
				opendir(DIR, "$smiliesdir"); 
				@contents = readdir(DIR); 
				closedir(DIR); 
				foreach $line (sort {uc($a) cmp uc($b)} @contents){ 
					($name, $extension) = split (/\./, $line); 
					if ($extension =~ /gif/i || $extension =~ /jpg/i || $extension =~ /jpeg/i || $extension =~ /png/i ){ 
						if ($line !~ /banner/i) { 
							$moresmilieslist .= qq~      document.write("<img src='$smiliesurl/$line' align='bottom' alt='$name' border='0' onclick='javascript:MoreSmilies($i)' style='cursor:hand' /> ");\n~; 
							$more_smilie_array .= qq~" [smiley=$line]", ~; 
							$i++ 
						} 
					} 
				} 
			}
			$more_smilie_array .= qq~""~; 
			}
			if ($enable_quickyabbc == 1) {
			$yymain .= qq~
        	<tr><td valign="top" width="23%">&nbsp;</td>
			<td><table><tr><td>
			<script language="JavaScript1.2" type="text/javascript">
          HAND = "style='cursor: pointer; cursor: hand;'";
          document.write("<img src='$defaultimagesdir/url.gif' onclick='hyperlink();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'257'}' title='$post_txt{'257'}' border='0' />");
          document.write("<img src='$defaultimagesdir/ftp.gif' onclick='ftp();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'434'}' title='$post_txt{'434'}' border='0' />");
          document.write("<img src='$defaultimagesdir/img.gif' onclick='image();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'435'}' title='$post_txt{'435'}' border='0' />");
          document.write("<img src='$defaultimagesdir/email2.gif' onclick='emai1();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'258'}' title='$post_txt{'258'}' border='0' />");
          document.write("<img src='$defaultimagesdir/flash.gif' onclick='flash();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'433'}' title='$post_txt{'433'}' border='0' />");
          document.write("<img src='$defaultimagesdir/table.gif' onclick='table();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'436'}' title='$post_txt{'436'}' border='0' />");
          document.write("<img src='$defaultimagesdir/tr.gif' onclick='trow();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'449'}' title='$post_txt{'449'}' border='0' />");
          document.write("<img src='$defaultimagesdir/td.gif' onclick='tcol();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'437'}' title='$post_txt{'437'}' border='0' />");
          document.write("<img src='$defaultimagesdir/hr.gif' onclick='hr();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'531'}' title='$post_txt{'531'}' border='0' />");
          document.write("<img src='$defaultimagesdir/tele.gif' onclick='teletype();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'440'}' title='$post_txt{'440'}' border='0' />");
          document.write("<img src='$defaultimagesdir/code.gif' onclick='showcode();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'259'}' title='$post_txt{'259'}' border='0' />");
          document.write("<img src='$defaultimagesdir/quote2.gif' onclick='quote();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'260'}' title='$post_txt{'260'}' border='0' />");
          document.write("<img src='$defaultimagesdir/edit.gif' onclick='edit();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'603'}' title='$post_txt{'603'}' border='0' />");
          document.write("<img src='$defaultimagesdir/sup.gif' onclick='superscript();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'447'}' title='$post_txt{'447'}' border='0' />");
          document.write("<img src='$defaultimagesdir/sub.gif' onclick='subscript();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'448'}' title='$post_txt{'448'}' border='0' />");
          document.write("<img src='$defaultimagesdir/move.gif' onclick='move();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'439'}' title='$post_txt{'439'}' border='0' /></b>");
          document.write("<img src='$defaultimagesdir/timestamp.gif' onclick='timestamp($date);' "+HAND+" align=top width=23 height=22 alt='$post_txt{'245'}' title='$post_txt{'245'}' border='0' /><br />");
          document.write("<img src='$defaultimagesdir/bold.gif' onclick='bold();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'253'}' title='$post_txt{'253'}' border='0' />");
          document.write("<img src='$defaultimagesdir/italicize.gif' onclick='italicize();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'254'}' title='$post_txt{'254'}' border='0' />");
          document.write("<img src='$defaultimagesdir/underline.gif' onclick='underline();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'255'}' title='$post_txt{'255'}' border='0' />");
          document.write("<img src='$defaultimagesdir/strike.gif' onclick='strike();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'441'}' title='$post_txt{'441'}' border='0' />");
          document.write("<img src='$defaultimagesdir/highlight.gif' onclick='highlight();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'246'}' title='$post_txt{'246'}' border='0' /></b>");
          document.write('<select name="fontface" id="fontface" onchange="if(this.options[this.selectedIndex].value) fontfce(this.options[this.selectedIndex].value);" style="width: 93px; margin-top: 2px; margin-left: 2px; margin-right: 1px; font-size: 9px;">');
          document.write('<option value="">Verdana</option>');
          document.write('<option value="">\\-\\-\\-\\-\\-</option>');
          document.write('<option value="Sans-Serif" style="font-family: Sans-Serif">Sans-Serif</option>');
          document.write('<option value="Verdana" style="font-family: Verdana" selected="selected">Verdana</option>');
          document.write('<option value="Arial" style="font-family: Arial">Arial</option>');
          document.write('<option value="Serif" style="font-family: Serif">Serif</option>');
          document.write('<option value="Courier" style="font-family: Courier">Courier</option>');
          document.write('<option value="Courier New" style="font-family: Courier New">Courier New</option>');
          document.write('<option value="Fantasy" style="font-family: Fantasy">Fantasy</option>');
          document.write('<option value="monospace" style="font-family: monospace">Monospace</option>');
          document.write('</select>');
          document.write('<select name="fontsize" id="fontsize" onchange="if(this.options[this.selectedIndex].value) fntsize(this.options[this.selectedIndex].value);" style="width: 39px; margin-top: 2px; margin-left: 1px; margin-right: 2px; font-size: 9px;">');
          document.write('<option value="">11</option>');
          document.write('<option value="">\\-\\-</option>');
          document.write('<option value="6">6</option>');
          document.write('<option value="7">7</option>');
          document.write('<option value="8">8</option>');
          document.write('<option value="9">9</option>');
          document.write('<option value="10">10</option>');
          document.write('<option value="11" selected="selected">11</option>');
          document.write('<option value="12">12</option>');
          document.write('<option value="14">14</option>');
          document.write('<option value="16">16</option>');
          document.write('<option value="18">18</option>');
          document.write('<option value="20">20</option>');
          document.write('<option value="22">22</option>');
          document.write('<option value="24">24</option>');
          document.write('<option value="36">36</option>');
          document.write('<option value="48">48</option>');
          document.write('<option value="56">56</option>');
          document.write('<option value="72">72</option>');
          document.write('</select>');
          document.write("<img src='$defaultimagesdir/pre.gif' onclick='pre();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'444'}' title='$post_txt{'444'}' border='0' />");
          document.write("<img src='$defaultimagesdir/left.gif' onclick='left();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'445'}' title='$post_txt{'445'}' border='0' />");
          document.write("<img src='$defaultimagesdir/center.gif' onclick='center();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'256'}' title='$post_txt{'256'}' border='0' />");
          document.write("<img src='$defaultimagesdir/right.gif' onclick='right();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'446'}' title='$post_txt{'446'}' border='0' />");
          document.write("<img src='$defaultimagesdir/list.gif' onclick='list();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'261'}' title='$post_txt{'261'}' border='0' />");
          document.write("<img src='$defaultimagesdir/me.gif' onclick='me();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'604'}' title='$post_txt{'604'}' border='0' />");
          document.write("</td><td>");

          		img1 = new Image();
          		img1.src = "$defaultimagesdir/palette.gif";
             	         </script>
             	         
        <div style="height: 42px; width: 86px; overflow: auto; border: 1px; border-style: outset; float: right;">
        ~;
        for($z=0; $z<256; $z+=51) {
          $c3 = sprintf ("%02x", $z);
          for($y=0; $y<256; $y+=51) {
            $c2 = sprintf ("%02x", $y);
            for($x=0; $x<256; $x+=51) {
              $c1 = sprintf ("%02x", $x);
              $selcolor = qq~#$c1$c2$c3~;
if($ENV{'HTTP_USER_AGENT'} =~ /Safari/) {$yymain .= qq~<span style="background-color: $selcolor; width: 11px; height: 11px;"><img src="$defaultimagesdir/palette.gif" border="0" hspace="0" vspace="0" alt="" style="height: 11px; width: 11px; margin: 0px;" onclick="showcolor('$selcolor')" /></span>~;}
else {$yymain .= qq~<span style="float: left; background-color: $selcolor; width: 9px; height: 9px; border: 1px outset; font-size: 5px;" onclick="showcolor('$selcolor')">&nbsp;</span>~;}
            }
if($ENV{'HTTP_USER_AGENT'} =~ /Safari/) {$yymain .= qq~<br />~;}
          }
        }
        $yymain .= qq~
        </div>
        </td></tr></table>
        
          </td>
        </tr>
        ~;
    	}
	if ($enable_quicksmilies == 1) {
        $yymain .= qq~
        <tr>
          <td valign="top" width="23%"><font size="2"><b>$post_txt{'297'}:</b></font></td>
          <td valign="middle">
          <script language="JavaScript1.2" type="text/javascript">
          <!--
            moresmiliecode = new Array($more_smilie_array) 

            function MoreSmilies(i) { 
              AddTxt=moresmiliecode[i]; 
              AddText(AddTxt); 
            }

            function smiliewin() {
              window.open("$smiliewinlink", 'list', 'width=$winwidth,height=$winheight, scrollbars=yes');
            }
    	  HAND = "style='cursor: pointer; cursor: hand;'";
            if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4)) {
          document.write("<img src='$defaultimagesdir/smiley.gif' onclick='smiley();' "+HAND+" align=bottom alt='$post_txt{'287'}' title='$post_txt{'287'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/wink.gif' onclick='wink();' "+HAND+" align=bottom alt='$post_txt{'292'}' title='$post_txt{'292'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/cheesy.gif' onclick='cheesy();' "+HAND+" align=bottom alt='$post_txt{'289'}' title='$post_txt{'289'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/grin.gif' onclick='grin();' "+HAND+" align=bottom alt='$post_txt{'293'}' title='$post_txt{'293'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/angry.gif' onclick='angry();' "+HAND+" align=bottom alt='$post_txt{'288'}' title='$post_txt{'288'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/sad.gif' onclick='sad();' "+HAND+" align=bottom alt='$post_txt{'291'}' title='$post_txt{'291'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/shocked.gif' onclick='shocked();' "+HAND+" align=bottom alt='$post_txt{'294'}' title='$post_txt{'294'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/cool.gif' onclick='cool();' "+HAND+" align=bottom alt='$post_txt{'295'}' title='$post_txt{'295'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/huh.gif' onclick='huh();' "+HAND+" align=bottom alt='$post_txt{'296'}' title='$post_txt{'296'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/rolleyes.gif' onclick='rolleyes();' "+HAND+" align=bottom alt='$post_txt{'450'}' title='$post_txt{'450'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/tongue.gif' onclick='tongue();' "+HAND+" align=bottom alt='$post_txt{'451'}' title='$post_txt{'451'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/embarassed.gif' onclick='embarassed();' "+HAND+" align=bottom alt='$post_txt{'526'}' title='$post_txt{'526'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/lipsrsealed.gif' onclick='lipsrsealed();' "+HAND+" align=bottom alt='$post_txt{'527'}' title='$post_txt{'527'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/undecided.gif' onclick='undecided();' "+HAND+" align=bottom alt='$post_txt{'528'}' title='$post_txt{'528'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/kiss.gif' onclick='kiss();' "+HAND+" align=bottom alt='$post_txt{'529'}' title='$post_txt{'529'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/cry.gif' onclick='cry();' "+HAND+" align=bottom alt='$post_txt{'530'}' title='$post_txt{'530'}' border='0' /> ");
	  $moresmilieslist
      	    }
            else { document.write("<font size='1'>$post_txt{'215'}</font>"); }
          //-->
          </script>~;
		if ($showadded == 3 || ($showadded == 2 && $detachblock == 1) || $showsmdir == 3 || ($showsmdir == 2 && $detachblock == 1)){
			$yymain .= qq~
          <a href=javascript:smiliewin()>$smiltxt{'1'}</a>~;
		}
		$yymain .= qq~ 
          <noscript>
            <font size="1">$post_txt{'215'}</font>
          </noscript>
          </td>
        </tr>~;
		}
	$yymain .= qq~
        <tr>
          <td valign="top" width="23%"><font size="2"><b>$post_txt{'72'}:</b></font></td>
          <td><textarea name="message" id="message" rows="10" cols="80" style="height: 200px; width: 98%; padding: 5px; margin: 0px; visibility: visible;" ONCLICK="javascript:storeCaret(this);" ONKEYUP="javascript:storeCaret(this);" ONCHANGE="javascript:storeCaret(this);" style="width:100%"></textarea>
        <script language="JavaScript1.2" type="text/javascript">
        <!--
        var postfieldobj;
        var postfieldid;
        postfieldid = 'message'; 
        postfieldobj = document.getElementById( postfieldid );
        function std_window_resize( pix ) {
        var box = postfieldobj;
        var cur_height = parseInt( box.style.height ) ? parseInt( box.style.height ) : 300;
        var new_height = cur_height + pix;
        if ( new_height > 0 ) { box.style.height = new_height + "px"; }
        return false;
        }
        //-->
        </script>
        <div style="float: left; text-align: left;">
        <input type="button" value=" + " onclick='std_window_resize( 100  );' id="rtesizeplus" />
        <input type="button" value=" - " onclick='std_window_resize( -100 );' id="rtesizeminus" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
        </div></td>
        </tr>
~;
	# File Attachment's Browse Box Code
	if (&AccessCheck($currentboard, 4) eq "granted") {
		if ($enable_quickattach == 1 && $allowattach == 1 && ${$uid.$currentboard}{'attperms'} == 1 && $fa_ok == 1 && (($allowguestattach == 0 && !$iamguest) || $allowguestattach == 1)) {
			$yymain .= qq~
	<tr>
		<td width="23%" valign="top"><b>$qrb_txt{'11'}</b></td>
		<td width="77%"><input type="file" name="file" size="50"$selnewatt /></td>
	</tr>
	<tr>~;
		}
	}
	# /File Attachment's Browse Box Code

	$yymain .= qq~
      </table>
    </td>
  </tr>
  <tr>
    <td align="center" class="catbg" bgcolor="$color{'catbg'}"><input type="submit" name="post" value="$post_txt{'105'}" accesskey="s" /> &nbsp; <input type="submit" name="preview" value="$post_txt{'507'}" accesskey="p" tabindex="6" /> &nbsp; <input type="reset" name="clear" value="$post_txt{'278'}" accesskey="r" /></td>
  </tr>
</table>
</form>
~;
	}

### Quick Reply Box ###

	$yytitle = $boardname;
	&template;
	exit;
}

sub MarkRead {

	# Mark all threads in this board as read.
	&dumplog("$currentboard--mark");
	$yySetLocation = qq~$scripturl?board=$currentboard~;
	&redirectexit;
}

sub ListPages {
	my $testthread = $INFO{'num'};
	$mreplies   = ${$testthread}{'replies'};
	$mviews     = ${$testthread}{'views'};
	$lastposter = ${$testthread}{'lastposter'};
	$tmpa       = 1;
	for ($tmpb = 0; $tmpb < $mreplies; $tmpb += $maxmessagedisplay) {
		$pages .= qq~<a href="$scripturl?num=$INFO{'num'}/$tmpb#$tmpb">$tmpa</a>\n~;
		++$tmpa;
	}
	$pages =~ s/\n\Z//;
	$yymain  = qq~<p align="center">&#171; $messageindex_txt{'139'} $pages &#187;</p><br />~;
	$yytitle = "$messageindex_txt{'139'} $messageindex_txt{'18'}";
	&template;
}

sub MessagePageindex {
	my ($msindx, $trindx, $mbindx);
	($msindx, $trindx, $mbindx) = split(/\|/, ${$uid.$username}{'pageindex'});
	if ($INFO{'action'} eq "messagepagedrop") {
		${$uid.$username}{'pageindex'} = qq~0|$trindx|$mbindx~;
	}
	if ($INFO{'action'} eq "messagepagetext") {
		${$uid.$username}{'pageindex'} = qq~1|$trindx|$mbindx~;
	}
	&UserAccount($username, "update");
	&redirectinternal;
	exit;
}

1;

